/*
   last change: $Revision: 150 $ $Author: rony $ $Date: 2006-02-08 01:13:05 +0100 (Wed, 08 Feb 2006) $

on os2: get everything expanded from VACPP;
        use a java-include > 1.1.8 (which has EnsureCapacity()), otherwise you cannot compile successfully,
        at runtime the correct versions are invoked

        icc.exe /Tdp -DOS2 /DIBMVACPP /P+ BSF4Rexx.cch


testing on os2 (not working yet): wcl386 -cc++ BSF4Rexx.cc -DOS2 -d2t @b4r_watcom.rsp

        wcl386 -c -cc++ BSF4Rexx.cc -DOS2 -d2t
        wcl386 -c -cc++ BSF4Rexx.cc -DOS2 -od
        wlink @b4r_watcom.lnk


wcl386 -c -cc++ BSF4Rexx.cc -DOS2 -od -bd -bm
wcl386 -c -cc++ BSF4Rexx.cc -DOS2 -od -bd -bm -DDEBUG -DDEBUG1 -DDEBUG2 -DDEBUG3 -DDEBUG_THREADS -DCAN_HANDLE_DLLIMPORT

wcl386 -c -cc++ BSF4Rexx.cc -DOS2 -od -bd -bm -zp4
-zu
-5s
-br

        --------------- cut here -----------------
icc.exe /O+ /Tdp -DOS2 /DIBMVACPP /Sa /Q /Gm /Ge- /Ms /C /FoBSF4Rexx-os2.obj BSF4Rexx.cc

/O+     ... optimize
/Tdp    ... program a c++
/Sa     ... ANSI/ISO
/Q      ... suppress logo
/Gm     ... link with multithreaded library
/Ge-    ... use the DLL runtime library
/Ms     ... set default calling convention to _System
/C      ... compile only, no linking


.\bsf4rexx-os2.map .\BSF4Rexx-os2.dll : .\BSF4Rexx-os2.obj {$(LIB)}REXX.LIB {$(LIB)}BSF4Rexx.def
    @echo " Link::Linker "
    icc.exe @<<
     /Q /B"/noe /m "
     /FeBSF4Rexx-os2.dll
     /Fm"bsf4rexx-os2.map"
     REXX.LIB
     BSF4Rexx.def
     .\BSF4Rexx-os2.obj
<<

    "/noe" ... no extended dictionary
    "/m"   ... create map-file
    /q     ... suppress the logo

        ------- cut here -------
        bsf4rexx.def

; 'INITINSTANCE' important for OS/2 (IBM's VACPP)
LIBRARY BSF4Rexx INITINSTANCE
HEAPSIZE  40960
STACKSIZE 40960
DESCRIPTION 'BSF4Rexx/rgf 2003'

; 'DATA' statement as is important for OS/2 (IBM's VACPP)
; on Windows, MSVACPP will warn, but ignore the statement
DATA MULTIPLE NONSHARED READWRITE

; functions in the DLL to be made available to other programs
EXPORTS BSF
EXPORTS Java_com_ibm_bsf_engines_rexx_RexxAndJava_jniRexxStart
EXPORTS Java_com_ibm_bsf_engines_rexx_RexxAndJava_jniRegisterBSF

; 2003-01-21, ---rgf, support for calling & registering from Rexx
EXPORTS BSFINVOKEDBY                = BsfInvokedBy
EXPORTS BSFLOADFUNCS                = BsfLoadFuncs
EXPORTS BSFDROPFUNCS                = BsfDropFuncs
EXPORTS BSFLOADJAVA                 = BsfLoadJava
EXPORTS BSFUNLOADJAVA               = BsfUnloadJava

; 2003-01-26, ---rgf, support for informational functions
EXPORTS BSFVERSION                  = BsfVersion
EXPORTS BSFQUERYALLFUNCTIONS        = BsfQueryAllFunctions
EXPORTS BSFQUERYREGISTEREDFUNCTIONS = BsfQueryRegisteredFunctions

; 2003-08-06, ---rgf, support for threads
EXPORTS BSFATTACHTOTID              = BsfAttachToTID
EXPORTS BSFGETTID                   = BsfGetTID




  * This DLL registers the function "BSF" with Rexx;
  * it allows Java to call into Rexx using the fine RexxSAA-interface
  * conventions and JNI ("Java Native Interface").
  *
  * last change: $Revision: 150 $ $Author: rony $ $Date: 2006-02-08 01:13:05 +0100 (Wed, 08 Feb 2006) $
  *
  * version:
  *                2.6.0 2006-02-xx, removed all JNI 1.1 code
  *
  *                2.5.9 2006-01-28, changed logic for RXSIO exit to allow compiling under Linux [of min() function
  *                                  not available on gcc], also inserted an elipsis (...) if truncating a Rexx
  *                                  stderr string to fit into 512 bytes per line);
  *                                  fixed conversion omission: now converts JavaString in Java-passed-in arguments
  *                                  to a native string (byte array translated according to local codepage) for the
  *                                  Rexx arguments
  *
  *                2.5.8 2006-01-27, created a RXSIO exit, which memorizes stderr-outputs from Rexx; in case of
  *                                  an execution error, the last three lines (containing the Rexx error message)
  *                                  are used to create a Java exception (org.apache.bsf.BSFException)
  *
  *                2.5.7 2006-01-22, BSF() now returns the result translated to a native string using the current
  *                                  codepage
  *
  *                2.5.6 2006-01-06, if Rexx arguments do not set java.class.path and the CLASSPATH environment
  *                                  variable is set, then use that value for starting up the JVM
  *
  *                2.5.6 2006-01-04, changed loading JVM, with JNI >= 1_2 now all Rexx arguments are passed through,
  *                                  started to enclose JNI_1_1 code in "#ifdef SUPPORT_JNI_1_1" to eventually
  *                                  get rid of it
  *
  *                2.5.4 2005-08-30, changed license to Apache v2.0, CPLv1.0;
  *                                  adjusted version number to match the Java support program ones
  *
  *                2.1.3 2005-06-02, moved RexxEngine to 'org.rexxla.bsf.engines', code adopted,
  *                                  removed dependency on "com.ibm.bsf" and "org.apache.bsf": will be addressed by the Rexx engine
  *
  *                2.1.2 2003-08-14, Linux-version works (with Java 1.4); needed to
  *                                  remove DetachCurrentThread() to prohibit exceptions
  *                                  in Sun's native "java" code; also removes occassional traps
  *                                  on Windows for Java 1.3 and 1.4
  *
  *                2.1.1 2003-08-11, started to adapt to Linux and OS/2 (eComStation)
  *
  *                2.1.1 2003-08-09, started to add ability to use this DLL for JNI 1.1 (Java 1.1) *and* 1.2 (Java 1.2, 1.3, 1.4)
  *                                  (some remarks: on Java 1.1 - global references in Hashtable will return *local* references;
  *                                  on Java 1.2 - UTF-strings need to be pinned down with global references;
  *                                  on Java 1.2, 1.3, 1.4 - sometimes JNI looses thread-infox it seems; "healed"
  *                                  by attaching again, although env was received by JNI!)
  *
  *                2.1.0 2003-08-08, takes care of threaded Object Rexx programs calling
  *                                  back at the same time, but potentially using different physical
  *                                  threads (under control of the Object Rexx thread-dispatcher)
  *
  *                2.0.0 2003-04-30, as BSFManager caches the RexxEngine it is important to make
  *                                  sure that the BSF-functions are registered before the Rexx
  *                                  script gets executed by the Rexx interpreter, ---rgf
  *                                  now lists the BSFFunctions in alphabetical order
  *
  *                2.0.0 2003-04-16, final version to be introduced at the 2003 International Rexx Symposium
  *                                  caters for IBM (BSF 2.2) and Apache (BSF 2.3 and higher)
  *
  *                1.9.4 2003-04-14, adjusted Rexx memory to what it is supposed to be, ie.:
  *                                  - never release memory allocated by Rexx
  *                                  - if allocating memory, then freeing it is o.k.
  *                                  - Rexx creates RXSTRINGS with a buffer size of 256L (RXAUTOBUFLEN)
  *                                    if size is not sufficient, create a larger buffer, but do
  *                                    NOT free Rexx'
  *
  *                1.9.3 2003-04-05, adjusted for Linux (RH 7.2)
  *                1.9.2 2003-02-19, switched arguments for BsfLoadJava, now arg(1)=classpath,
  *                     arg(2)=Append/Prepend;
  *                1.9.1 2003-02-12, adjusting for JNI 1.1 *and* 1.2 (as starting with
  *                     Java 1.4 the JNI 1.1 interface does not work anymore (just bombs)
  *
  *                1.9.0 2003-01-27, ---rgf, added ability to load JVM from the Rexx side,
  *                     initializing BSF4Rexx from the Java side as well, such that all of
  *                     BSF4Rexx' functionality is available to Rexx programs started by Rexx
  *
  *                1.2.1 2003-01-06, ---rgf, finally found bug causing Object Rexx to bomb (but also Regina, it turned out!)
  *                               reason: freeing memory for Rexx-code with wrong method !
  *
  *                2003-01-05, ---rgf, adapted to Mark Hessling's great "Rexx/Trans"
  *                      (cf. <http://rexxtrans.sourceforge.net/>), which allows for
  *                      generic support for any supported Rexx interpreter, e.g.:
  *
  *                         Regina <http://regina-rexx.sourceforge.net/>,
  *                         IBM Object Rexx <http://www.software.ibm.com/ad/obj-rexx/>,
  *                         Quercus Systems Personal Rexx <http://www.quercus-sys.com/>,
  *                         Enterprise Rexx <http://www.WinREXX.com/>
  *
  *                 2001-06-11, ---rgf, runs with JNI 1 (does *not* need JRE 1.2 or higher
  *                         anymore, so OS/2 users with 1.1.8 can use this package as well)
  *
  * author:  (c) 2001-2003 Rony G. Flatscher, WU (pronounced: "vey-u") Vienna University of Economics
  *                          and Business Administration
  *                       (preliminary work by Peter Kalender (Oct 2000 to Feb 2001), University of Essen)
  *
  *  LICENSE:

    ------------------------ Apache Version 2.0 license -------------------------
       Copyright 2001-2006 Rony G. Flatscher

       Licensed under the Apache License, Version 2.0 (the "License");
       you may not use this file except in compliance with the License.
       You may obtain a copy of the License at

           http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing, software
       distributed under the License is distributed on an "AS IS" BASIS,
       WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
       See the License for the specific language governing permissions and
       limitations under the License.
    -----------------------------------------------------------------------------

*/




#ifdef __cplusplus
extern "C" {            // make sure no C++ name mangling comes into the way
#endif




// Java 1.1 o.k., Java 1.2 trap-popup-window, Java 1.3 shows DLLs does NOT create log-file,
// Java 1.4 just shows there is "Another exception while handling last error ..

// #define DEBUG
// #define DEBUG0
// #define DEBUG1
// #define DEBUG2
// #define DEBUG3
// #define DEBUG_THREADS

    // there is a problem with Java 1.2, 1.3, 1.4 with env->DetachCurrentThread()
    // and Object Rexx on Linux, but also on Windows, if Rexx programs are started via Java
// #define USE_DETACH_CURRENT_THREAD


#define INCL_RXSYSEXIT          // ---rgf, 2006-01-27: include Rexx exit definitions

#ifdef OS2
   #define ALLOW_LOADING_JVM    // as of 2006-02-06, allow again

   #define INCL_DOSMEMMGR

   #define INCL_DOSMODULEMGR    // from RexxTrans
   #define INCL_DOSMISC         // from RexxTrans

   #define INCL_DOSPROCESS      // rgf, 20030818, for DosSleep()

   #include <os2.h>
   #include <bse.h>

//   #define CAN_HANDLE_DLLIMPORT // define, if OS/2-compiler can handle "__declspec(dllimport)"
#endif



#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>


#ifdef WINDOWS                  //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
   #define ALLOW_LOADING_JVM
#endif


#ifdef UNIX
   #include <dlfcn.h>       // use the dynamic link functions

    // Object Rexx 2.3.3 (2002-11-26) under Unix sometimes looses track of the registered external BSF-functions
    // Object Rexx 2.1.? seems to "forget" registered external functions in its threads
   #define CHECK_4_FORGOTTEN_BSF_FUNCTIONS

   #ifndef __APPLE__    // not for Apple (would need to split off the JVM loading part)
       #define ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
   #endif
#endif

#define INCL_RXSHV
#define INCL_RXFUNC

#ifdef USE_REXXTRANS
# include <rexxtrans.h>

#elif defined USE_OREXX
# include <rexx.h>

#else
# include <rexxsaa.h>
#endif


#ifdef OS2
   #ifndef RXFUNC_NOTREG
      #define RXFUNC_NOTREG 30  // possibly not in OS/2's REXX.H
   #endif

   #ifndef RXAUTOBUFLEN
      #define RXAUTOBUFLEN 256L // possibly not in OS/2's REXX.H
   #endif
#endif



      // under Linux gcc RH 7.3 not defined, ---rgf, 2003-04-05
#ifndef FALSE
    #define FALSE 0
#endif

#ifndef INT
    #define INT int
#endif
    // end (Linux RH 7.2)


#ifdef _MSC_VER
# pragma warning(disable:4100)
#endif




//   #ifdef __cplusplus
//   extern "C" {            // make sure no C++ name mangling comes into the way
//   #endif


// -------------------- JNI-interface related
#ifdef OS2
                        // IBM VACPP 3.x cannot handle "__declspec(dllexport)"
    #ifdef IBMVACPP
    // JNI-related prototypes
        // 2003-08-23, for OS/2
       #define PROTOTYPE_JNI_ONLY
    #endif
#endif


#include "org_rexxla_bsf_engines_rexx_RexxAndJava.h" // rgf, 2005-06-02

    // JNI 1.1 related prototypes
/*
typedef                        jint (JNICALL *rgfAttachCurrentThread_JNI_1_1) (JavaVM*, JNIEnv **, void *);
typedef                        jint (JNICALL *rgfCreateJavaVM_1_1) (JavaVM **, JNIEnv **, void *);
typedef                        jint (JNICALL *rgfGetDefaultJavaVMInitArgs_1_1) (void *);
*/

// the following does not work as <jni.h> got included above already
//
//     // JNI 1.2 related prototypes
// #if defined ( OS2 ) // && ( IBMVACPP )
//         // now undefine
//     #undef PROTOTYPE_JNI_ONLY
//     #include <jni.h>        // now re-include (seems to not work)
// #endif


typedef                        jint (JNICALL *rgfAttachCurrentThread_JNI_1_2) (JavaVM*, void **, void *);

typedef
/*
  #if defined ( OS2 ) && defined ( CAN_HANDLE_DLLIMPORT )
      __declspec(dllimport)
  #else
      _JNI_IMPORT_OR_EXPORT_
  #endif
*/
    jint (JNICALL *rgfCreateJavaVM_1_2) (JavaVM **, void **, void *);

typedef
/*
  #if defined ( OS2 ) && defined ( CAN_HANDLE_DLLIMPORT )
       __declspec(dllimport)
  #else
       _JNI_IMPORT_OR_EXPORT_
  #endif
*/
    jint (JNICALL *rgfGetDefaultJavaVMInitArgs_1_2) (void *);



typedef struct {
   PVOID createJVM;
   PVOID queryVMInitArgs;
} procAddresses ;



#define BSF_VERSION     "260.20060206 org/rexxla/bsf/engines/rexx"  // version: "MajorNumber"."YYYYMMDD"
#define JAVA_4_REXX     "org/rexxla/bsf/engines/rexx/Java4Rexx"     // 2005-06-02, supportive Java4Rexx-class

#define RGF_RXSIO_EXIT_NAME         Rgf_RXSIO_Exit     // ---rgf, 2006-01-27
#define RGF_RXSIO_EXIT_NAME_STRING "Rgf_RXSIO_Exit"    // ---rgf, 2006-01-27

typedef struct {
   PCHAR strBuffer ;        // buffer to contain the last four lines to stderr (< 512bytes)
   PINT  intBuffer ;        // [0] ... present count, [1] ... points to next entry (0...3)
} RGF_STDERR_BUFFER ;



#define HASHTABLE_CLASSNAME "java/util/Hashtable"  // ---rgf, 2003-08-04


#define DLLNAME         "BSF4Rexx"      // name of DLL and name for "PARSE SOURCE"
#define JAVA_CALL_BSF   "javaCallBSF"   // name of Java method to carry out the BSF-call

#define  INVALID_ROUTINE 40            /* Rexx: raise Rexx error # 40   */
#define  VALID_ROUTINE    0            /* Rexx: successful completion   */

int       JNI_RUNTIME_VERSION = 0;     // Java versions: 1=1.1, 2=1.2, 4=1.4, ...
int       JNI_VERSION = 2;      // JNI in use, can be "1" (JNI 1.1) or "2" (JNI 1.2 or higher)

JNIEnv    *oldGlobEnv =NULL, *globEnv =NULL;    // used by BSF() to call back to Java
jobject    oldGlobObj =NULL,  globObj =NULL;    // used by BSF() to call back to Java

jmethodID  oldGlobMid =NULL,  globMid =NULL;    // used by BSF() to call back to Java
JavaVM    *oldGlobJvm =NULL, *globJvm =NULL;    // used by BsfLoadJava(), BsfUnloadJava()
JavaVM    *globJavaVM=NULL;                     // stores JVM-pointer, if invoked by Java
jobject    oldGlobORef=NULL,  globORef=NULL;    // this stores the global reference to the object, pinning the JVM

// Hashtable object to store TID->JavaObject for multiple Rexx-programs or Rexx-threads to call BSF, ---rgf, 2003-08-04
// Will also be used for locking using Java for executing critical sections in native code
jobject   HASHTABLE=NULL;               // Hashtable object
jclass    HASHTABLE_CLASS_OBJECT=NULL;  // Hashtable class object
jmethodID HASHTABLE_MID_CONTAINSKEY,    // MID for containsKey-method
          HASHTABLE_MID_PUT=NULL,       // MID for put-method
          HASHTABLE_MID_GET=NULL,       // MID for get-method
          HASHTABLE_MID_REMOVE=NULL;    // MID for remove-method

jclass    JAVA_LANG_STRING_CLASS_OBJECT  = NULL;    // java.lang.String class object
jmethodID STRING_MID_INIT_FROM_BYTEARRAY = NULL,    // <init> with byte-array
          STRING_MID_GETBYTES            = NULL;    // "getBytes"-method

jclass    JAVA_REXX_AND_JAVA_CLASS_OBJECT = NULL; // RexxAndJava class object
jstring   JAVA_EMPTY_UTF_STRING = NULL;   // will refer to an empty Java String object

    // calculate the needed bytes for representing a pointer as hex-string with trailing \0
const int CONST_LENGTH_OF_POINTER_0 = sizeof( PVOID )*2+1;


#ifdef UNIX
   #define PATH_SEPARATOR ':'

#else   /* default to: DOS, WIN[32], OS2 */
   #define PATH_SEPARATOR ';'
#endif


#ifdef DEBUG        // ---rgf, 2003-04-30
    // --------------------------->
    inline void zeigeGlobs()    // show values for global variables
    {
    #ifdef DEBUG2
        // fprintf(stderr, "\tglobEnv=[%p](=TID), globObj=%p, globMid=%p,\n\tglobVm=%p, globORef=%p\n",globEnv, globObj, globMid, globJvm, globORef);
        fprintf(stderr, "   globObj=%p, globVm=%p, globORef=%p, globJavaVM=%p\n",
                            globObj, globJvm, globORef, globJavaVM);
    #endif
    }

#endif


    // inline function to carry out "AttachCurrentThread()" indpendent of JNI

inline void rgfAttachCurrentThread ( JavaVM *vm, JNIEnv * &env)
{
#ifdef DEBUG2
   fprintf(stderr, "rgfAttachCurrentThread(): vm=[%p], env=[%p], JNI_VERSION=[%d]\n", vm, env, JNI_VERSION);
#endif

        rgfAttachCurrentThread_JNI_1_2 rgfACT2 = NULL;
        // this indirection by-passes the compiler checks on MS VCC ...
        rgfACT2 = (rgfAttachCurrentThread_JNI_1_2) vm->functions->AttachCurrentThread;
        int i=rgfACT2(vm, (void **) &env, NULL);    // call AttachCurrentThread() in JNI >= 1.2 style

        if ( env->ExceptionOccurred() != NULL )
        {
            fprintf(stderr, "rgfAttachCurrentThread(): Exception occurred!\n");
            env->ExceptionDescribe();
            env->ExceptionClear();
        }

#ifdef DEBUG2
   fprintf(stderr, "                     now: vm=[%p], env=[%p]\n", vm, env);
#endif
}

inline void rgfDetachCurrentThread( JavaVM *vm, JNIEnv* & env)
{
#ifdef DEBUG2
   fprintf(stderr, "rgfDetachCurrentThread(): vm=[%p], env=[%p]\n", vm, env);
#endif
    vm->DetachCurrentThread();
#ifdef DEBUG2
   fprintf(stderr, "rgfDetachCurrentThread(): done.\n");
#endif

    if ( env->ExceptionOccurred() != NULL )
    {
        fprintf(stderr, "rgfDetachCurrentThread(): Exception occurred!\n");
        env->ExceptionDescribe();
        env->ExceptionClear();
    }
#ifdef DEBUG2
   fprintf(stderr, "rgfDetachCurrentThread(): about to return...\n");
#endif
}



        // inline function for taking care of the different ways of freeing Rexx-allocated memory
inline void RgfFreeMemory (void * memory)
{

#ifdef DEBUG2       // ---rgf, 2003-04-30
    fprintf(stderr, ">>> RgfFreeMemory() ... \n");
#endif

#if defined (USE_REGINA) || defined (USE_REXXTRANS)     // 2003-01-04, ---rgf, added defined (USE_REXXTRANS)
    #ifdef DEBUG2       // ---rgf, 2003-04-30
       fprintf(stderr, ">>> RgfFreeMemory(): 'USE_REGINA' or 'USE_REXXTRANS' defined, RexxFreeMemory()\n");
    #endif
    RexxFreeMemory( memory );

#elif defined WIN32
    #ifdef DEBUG2       // ---rgf, 2003-04-30
       fprintf(stderr, ">>> RgfFreeMemory(): 'WIN32' defined, GlobalFree()\n");
    #endif
    GlobalFree( memory );

#elif defined OS2
    #ifdef DEBUG2       // ---rgf, 2003-04-30
       fprintf(stderr, ">>> RgfFreeMemory(): 'OS2' defined, DosFreeMem()\n");
    #endif
    DosFreeMem( memory );

#else
    #ifdef DEBUG2       // ---rgf, 2003-04-30
       fprintf(stderr, ">>> RgfFreeMemory():  using free()\n");
    #endif
    free( memory );
#endif

}



    // inline function for reserving memory disposable for Rexx (guessing how Rexx is allocating it)
            // usage, e.g.: PSZ mem = (PSZ) RgfAllocateMemory(3451l);
inline PVOID RgfAllocateMemory(long size)
{
#ifdef DEBUG2       // ---rgf, 2003-04-30
    fprintf(stderr, ">>> RgfAllocateMemory() ... \n");
#endif

#if defined (USE_REGINA) || defined (USE_REXXTRANS)     // 2003-01-04, ---rgf, added defined (USE_REXXTRANS)
    #ifdef DEBUG2       // ---rgf, 2003-04-30
        fprintf(stderr, ">>> RgfAllocateMemory(): 'USE_REGINA' or 'USE_REXXTRANS' defined, RexxFreeMemory()\n");
    #endif
    return RexxAllocateMemory( size );       // RexxAllocMemory( nrOfBytes );

#elif defined WIN32
    #ifdef DEBUG2       // ---rgf, 2003-04-30
        fprintf(stderr, ">>> RgfAllocateMemory(): 'WIN32' defined, GlobalFree()\n");
    #endif

    // #define GMEM_FIXED 0x0000       // according to docs: if GMEM_FIXED is set, then a pointer to memory is returned
    return GlobalLock( GlobalAlloc( GMEM_FIXED, size) );

#elif defined OS2
    #ifdef DEBUG2       // ---rgf, 2003-04-30
        fprintf(stderr, ">>> RgfAllocateMemory(): 'OS2' defined, DosFreeMem()\n");
    #endif

    PVOID pmem = NULL;              // define a typeless pointer
    // #define PAG_WRITE 0x0000002     // define writable (should imply PAG_READ which would be 0x0000 0001)
    DosAllocMem( &pmem, size, PAG_WRITE | PAG_COMMIT );  // PAG_COMMIT from RexxTrans 1.6 (didn't find fPerm)
    return pmem;

#else       // hmm, don't know whether this makes sense
    #ifdef DEBUG2       // ---rgf, 2003-04-30
        fprintf(stderr,">>> RgfAllocateMemory():  using malloc()\n");
    #endif
    return malloc( size );
#endif
}




#ifdef DEBUG    // expects a Java-object/reference and displays its String representation
                // ---rgf, 2003-08
    void showInfos4jobject (JNIEnv *env, jobject jo, const char* title)
    {
        fprintf(stderr, "===> si4o(): env=[%p], jo=[%p] title=[%s]\n", env, jo, title);
        if (jo==NULL)
        {
            fprintf(stderr, "\tNULL-value, returning prematurely from si4o()...\n\n");
            return;
        }

        // obj2string(env, jo);

        jclass joc=(*env).GetObjectClass(jo);

        // --rgf, 2003-08-09
        jclass jocc=(*env).GetObjectClass(joc);
        jmethodID jmidName2=(*env).GetMethodID(jocc, "toString", "()Ljava/lang/String;");
        fprintf(stderr, "===>\t\tjmidName2=[%p]\n", jmidName2);
        jobject   jobj2=(*env).CallObjectMethod(joc, jmidName2, NULL);

        if ( env->ExceptionOccurred() != NULL )
        {
            env->ExceptionDescribe();
            env->ExceptionClear();
        }

        // obj2string(env, (jobject) joc);
        fprintf(stderr, "===>\tjo=[%p], joc=[%p] \n", jo, joc);

        jmethodID jmidName=(*env).GetMethodID(joc, "toString", "()Ljava/lang/String;");
        fprintf(stderr, "===>\t\tjmidName=[%p]\n", jmidName);
        //        jobject   jobj=(*env).CallObjectMethod(joc, jmidName, NULL);
        jobject   jobj=(*env).CallObjectMethod(jo, jmidName, NULL);

        if ( env->ExceptionOccurred() != NULL )
        {
            env->ExceptionDescribe();
            env->ExceptionClear();
        }

        fprintf(stderr, "===>\tjobj=[%p] ", jobj);
        const char *aha=(*env).GetStringUTFChars( (jstring) jobj, JNI_FALSE);
        fprintf(stderr, "ahaP=[%p] ", aha);
        fprintf(stderr, "ahaS=[%s]\n\n", aha);
        (*env).ReleaseStringUTFChars( (jstring) jobj, aha);

        // ----------------------------
        jobj=(*env).CallObjectMethod(jo, jmidName, NULL);

        if ( env->ExceptionOccurred() != NULL )
        {
            env->ExceptionDescribe();
            env->ExceptionClear();
        }

        fprintf(stderr, "===>\tjobj=[%p] jo.toString():\n", jobj);

        aha=(*env).GetStringUTFChars( (jstring) jobj, JNI_FALSE);
        fprintf(stderr, "===>\t[%s]\n", aha);

        (*env).ReleaseStringUTFChars( (jstring) jobj, aha);
        fprintf(stderr, "<=== si4o(): End of this run! <===\n\n");

        return;
    }
#endif



// copy & pasted from: The Java Native Interface Programmers Guide and Specification
// by Sheng Lian, downloaded from java.sun.org in July 2003 as PDF
// code edited to make it runnable under this DLL

// =======================
// cf. "6.1.2 A Utility Function"
void JNU_ThrowByName(JNIEnv *env, const char *name, const char *msg)
{
    jclass cls = (*env).FindClass(name);
    // if cls is NULL, an exception has already been thrown
    if (cls != NULL)
    {
        (*env).ThrowNew(cls, msg);
            // free the local ref
        (*env).DeleteLocalRef(cls);
    }
}


// =======================
// cf. "8.2.1 Creating jstrings from Native Strings"

jstring JNU_NewStringNative(JNIEnv *env, const char *str)
{
#ifdef DEBUG
   fprintf(stderr, "JNU_NewStringNative(): angekommen, env=[%p], str=[%s]\n", env, str);
#endif

    jstring    result;
    jbyteArray bytes = 0;
    int len;
    if ( JNI_VERSION > 1 && env->EnsureLocalCapacity(2) < 0)    // EnsureLocalCapacity introduced with JNI 1.2
    {
        return NULL; // out of memory error
    }
    len = strlen(str);
    bytes = env->NewByteArray(len);
    if (bytes != NULL)
    {
        if (STRING_MID_INIT_FROM_BYTEARRAY == NULL)   // MID already there ?
        {
            STRING_MID_INIT_FROM_BYTEARRAY = (*env).GetMethodID(JAVA_LANG_STRING_CLASS_OBJECT, "<init>", "([B)V");    // get constructor
        }

        env->SetByteArrayRegion(bytes, 0, len, (jbyte *)str);
        result = (jstring) env->NewObject(JAVA_LANG_STRING_CLASS_OBJECT, STRING_MID_INIT_FROM_BYTEARRAY, bytes);
        env->DeleteLocalRef(bytes);
        return result;
    } // else fall through

#ifdef DEBUG
   fprintf(stderr, "JNU_NewStringNative(): NULL wird zurckgegeben!\n");
#endif
    return NULL;
}


// =======================
// cf "8.2.2 Translating jstrings to Native Strings"
char *JNU_GetStringNativeChars(JNIEnv *env, jstring jstr)
{
#ifdef DEBUG
   fprintf(stderr, "JNU_GetStringNativeChars(): angekommen, env=[%p], str=[%p]\n", env, jstr);
#endif

    jbyteArray bytes = 0;
    jthrowable exc;
    char *result = 0;

#ifdef DEBUG
    if ( JNI_VERSION>1 && (*env).EnsureLocalCapacity(2) < 0)   // EnsureLocalCapacity introduced with JNI 1.2
    {
        return 0; // out of memory error
    }
#endif

    if (STRING_MID_GETBYTES == NULL)   // MID already there ?
    {
        STRING_MID_GETBYTES = (*env).GetMethodID(JAVA_LANG_STRING_CLASS_OBJECT, "getBytes", "()[B");    // get constructor
    }
    bytes = (jbyteArray) (*env).CallObjectMethod(jstr, STRING_MID_GETBYTES);
    exc = (*env).ExceptionOccurred();
    if (!exc)
    {
        jint len = (*env).GetArrayLength(bytes);
        result = (char *)malloc(len + 1);
        if (result == 0)
        {
            JNU_ThrowByName(env, "java/lang/OutOfMemoryError", 0);
            (*env).DeleteLocalRef(bytes);
            return 0;
        }
        (*env).GetByteArrayRegion(bytes, 0, len, (jbyte *)result);
        result[len] = 0; /* NULL-terminate */
    } else
    {
        (*env).DeleteLocalRef(exc);
    }
    (*env).DeleteLocalRef(bytes);
#ifdef DEBUG
   fprintf(stderr, "JNU_GetStringNativeChars(): returning [%p]...\n", result);
#endif

    return result;
}
// ------------- the end of copy & pasted functions form the above JNI Guide and Specification book





   // utility function to create an UTF jstring from an object reference
jstring JNU_ref2utf( JNIEnv *env, PVOID ref)
{
    char refStr [CONST_LENGTH_OF_POINTER_0]="";// get a char array whith enough room to store a pointer as a hexstring value

        // render pointer as a hexstring value
    sprintf(refStr, "%p%c", ref, 0);                // create a pointer hexstring value representation with a trailing \0
    return (*env).NewStringUTF(refStr);   // create a Java UTF-8 string to store the env-pointer hexstring value
}



   // utility function to create an object reference from an UTF jstring
PVOID JNU_utf2ref( JNIEnv *env, jstring utf)
{
    PCHAR aha = (PCHAR) env->GetStringUTFChars(utf, JNI_FALSE);

#ifdef DEBUG1
  fprintf(stderr, "JNU_utf2ref(): ahaS=[%s]\n", aha);
#endif
    PVOID ref = NULL;
    sscanf( aha, "%p", &ref);
#ifdef DEBUG1
  fprintf(stderr, "JNU_utf2ref(): refP=[%p]\n", ref);
#endif
    env->ReleaseStringUTFChars( utf, aha);
    return ref;
}




// ---rgf, 2003-08-07: testing under JNI 1.1 it seems that global references
//                     stored with the Hashtable object are being retrieved
//                     as local references

    // ---rgf, 2003-08-06
    // expects the TID (i.e. "env") and returns the Java object associated with it
jobject MT_Java_env_lookup (JNIEnv *env)
{
#ifdef DEBUG        // ---rgf, 2003-08-06
   fprintf(stderr, "MT_Java_env_lookup(): env=[%p]...\n", env);
#endif

//    (*env).MonitorEnter(HASHTABLE);    // make sure other threads accessing the hashtable are blocked
#ifdef DEBUG2
   fprintf(stderr, "\t\tMonitor enter worked, about to call COM...\n");
#endif

        // try to get the stored jobj
    jobject storedObj=(*env).CallObjectMethod(HASHTABLE, HASHTABLE_MID_GET, JNU_ref2utf(env, env) );
    if ( env->ExceptionOccurred() != NULL )
    {
        env->ExceptionDescribe();
        env->ExceptionClear();
    }

        // use jstring to re-create jobject (global reference)
    if (storedObj != NULL) storedObj=(jobject) JNU_utf2ref(env, (jstring) storedObj);

#ifdef DEBUG2
    fprintf(stderr, "\t\tstoredObj=[%p]\n", storedObj);
#endif

//   (*env).MonitorExit(HASHTABLE);     // end of critical section

#ifdef DEBUG2        // ---rgf, 2003-08-06
   fprintf(stderr, "\t...lookup(): after MonitorExit()...\n");
#endif


#ifdef DEBUG
    fprintf(stderr, "MT_Java_env_lookup(): returning storedObj [%p]...\n", storedObj );
#endif

    return storedObj; //
}



    // ---rgf, 2003-08-06
    // expects the TID (i.e. "env") and returns the Java object associated with it
jobject MT_Java_env_remove (JNIEnv *env)
{
#ifdef DEBUG        // ---rgf, 2003-08-06
   fprintf(stderr, "MT_Java_env_remove(): env=[%p]...\n", env);
#endif

#ifdef DEBUG2        // ---rgf, 2003-08-07
   fprintf(stderr, "\t...remove(): before MonitorEnter()...\n");
#endif

//    (*env).MonitorEnter(HASHTABLE);    // make sure other threads accessing the hashtable are blocked
    jobject storedObj=(*env).CallObjectMethod(HASHTABLE, HASHTABLE_MID_REMOVE, JNU_ref2utf(env, env) );
    if ( env->ExceptionOccurred() != NULL )
    {
        env->ExceptionDescribe();
        env->ExceptionClear();
    }

#ifdef DEBUG2
    fprintf(stderr, "\t...remove(): removed [pvKeyStr], received storedObj=[%p]\n", storedObj);
#endif
    //(*env).MonitorExit(HASHTABLE);     // end of critical section

#ifdef DEBUG2        // ---rgf, 2003-08-07
   fprintf(stderr, "\t...remove(): after MonitorExit()...\n");
#endif

        // delete global reference of old object, if one got stored
    if (storedObj != NULL)
    {
#ifdef DEBUG2
        fprintf(stderr, "\t...remove(): got storedObj [%p]...\n", storedObj );
#endif
            // if JNI runtime version >= 1.4, then it can retrieve the global references (this seems to work starting with Java 1.3)
        {
           storedObj=(jobject) JNU_utf2ref(env, (jstring) storedObj);
#ifdef DEBUG2
        fprintf(stderr, "\t...remove(): storedObj-casted=[%p]...\n", storedObj );
#endif
        }

#ifdef DEBUG2
   fprintf(stderr, "\t...remove(): returning storedObj [%p]...\n", JNU_utf2ref(env, (jstring) storedObj) );
   fprintf(stderr, "\t...remove(): before DeleteGlobalRef(storedObj=[%p])...\n", storedObj);
#endif

      env->DeleteGlobalRef(storedObj);

#ifdef DEBUG2        // ---rgf, 2003-08-07
   fprintf(stderr, "\t...remove(): AFTER  DeleteGlobalRef()!\n");
#endif
    }
    return storedObj;
}



    // ---rgf, 2003-08-06
    // for multithreaded usage (multiple Java and e.g. Object Rexx threads) it
    // is necessary to address the appropriate "RexxAndJava"-instance (with
    // its appropriate BSFManager BSFRegisty object).
    // "env" is being used as the Java-TID and an entry in HASHCODE is checked
    // where the key is "env" and the value is the global reference of the
    // RexxAndJava instance)
jobject MT_Java_env_set (JNIEnv *env, jobject obj)
{
#ifdef DEBUG        // ---rgf, 2003-08-06
   fprintf(stderr, "MT_Java_env_set(): just arrived! env=[%p], obj=[%p]...\n", env, obj);
#endif


    jobject newRef=NULL;        // global reference, if "obj" is a new instance

#ifdef DEBUG2        // ---rgf, 2003-08-06
   fprintf(stderr, "\t...set(): before MonitorEnter()...\n");
#endif
    (*env).MonitorEnter(HASHTABLE);    // make sure other threads accessing the hashtable are blocked
        // try to get the stored jobj, if any, free its global reference if not the same object
        // and create a new entry

    jstring utfKey=JNU_ref2utf(env, env);

#ifdef DEBUG1
   showInfos4jobject (env, HASHTABLE, "HASHTABLE-object (bevor):");

  fprintf(stderr, "\t...set(): before COM, HT=[%p], HTMIDGET=[%p], utfKey=[%p]\n",
                  HASHTABLE, HASHTABLE_MID_GET, utfKey);

    #ifndef IBMVACPP
      fprintf(stderr, "\t... ===> comP=[%p] [%p]\n", (*env).CallObjectMethod, env->CallObjectMethod);
    #endif

#endif
    jobject storedObj=(*env).CallObjectMethod(HASHTABLE, HASHTABLE_MID_GET, utfKey );
    if ( env->ExceptionOccurred() != NULL )
    {
#ifdef DEBUG1
  fprintf(stderr, "MT_Java_env_set(): after HASHTABLE_GET an exception !...\n");
#endif
        env->ExceptionDescribe();
        env->ExceptionClear();
    }

        // got a string? if so,
    if (storedObj!=NULL) storedObj=(jobject) JNU_utf2ref(env, (jstring) storedObj);

#ifdef DEBUG1
    fprintf(stderr, "\t...set(): retrieved from HASHTABLE: storedObj=[%p], obj=[%p]\n", storedObj, obj);
    showInfos4jobject(env, storedObj, "storedObj retrieved from HASHTABLE with utfKey!");
#endif

        // either no old object, or stored object not the same, hence store the new one!
    if (storedObj==NULL || env->IsSameObject(obj, storedObj) == JNI_FALSE)
    {
        newRef=(*env).NewGlobalRef(obj);    // create a global reference for the object, which called us

#ifdef DEBUG2
    fprintf(stderr, "\t...set(): NOT IsSameObject(obj, storedObj), hence created newRef=[%p]...\n", newRef);
#endif

            // create a new global reference & store new object
        jobject res=NULL;

#ifdef DEBUG2
  fprintf(stderr, "\t...set(): newRef=[%p] ===> JNU_ref2utf()=[%p], BEFORE insert !!!\n", newRef, JNU_ref2utf(env, newRef));
  showInfos4jobject(env, JNU_ref2utf(env, newRef), "utf with global reference pointer!");
#endif
        res=(*env).CallObjectMethod(HASHTABLE, HASHTABLE_MID_PUT, utfKey, JNU_ref2utf( env, newRef ) );
        if ( env->ExceptionOccurred() != NULL )
        {
#ifdef DEBUG1
  fprintf(stderr, "MT_Java_env_set(): after HASHTABLE_PUT an exception !...\n");
#endif
            env->ExceptionDescribe();
            env->ExceptionClear();
        }

#ifdef DEBUG2
    fprintf(stderr, "\t...set(): res=[%p]: newRef=[%p] created from obj=[%p]\n", res, newRef, obj);
#endif
    }

    (*env).MonitorExit(HASHTABLE);     // end of critical section

#ifdef DEBUG2        // ---rgf, 2003-08-06
   fprintf(stderr, "\t...set(): after MonitorExit()...\n");
#endif
        // delete global reference of old object, if one got stored
    if (newRef != NULL)     // a new reference was stored
    {
#ifdef DEBUG2        // ---rgf, 2003-08-07
   fprintf(stderr, "\t...set(): before DeleteGlobalRef(storedObj=[%p])...\n", storedObj);
#endif
        if (storedObj != NULL)
        {
                env->DeleteGlobalRef(storedObj);
#ifdef DEBUG2        // ---rgf, 2003-08-06
   fprintf(stderr, "\t...set(): AFTER DeleteGlobalRef().\n");
#endif
        }

#ifdef DEBUG2        // ---rgf, 2003-08-06
   showInfos4jobject (env, newRef, "newRef BEFORE returning it !!!"); // instance of Hashtable
#endif

#ifdef DEBUG        // ---rgf, 2003-08-06
   fprintf(stderr, "MT_Java_env_set(): returning newRef=[%p]\n", newRef );
#endif
        return newRef;
    }
#ifdef DEBUG        // ---rgf, 2003-08-06
   fprintf(stderr, "MT_Java_env_set(): returning storedObj=[%p]\n", storedObj);
#endif
    return storedObj;
}



/*  Save Java environment handle and java object handle, find for that environment and
 *  instance the method id for being able to call back into Java later via Rexx using
 *  the function BSF() in here. ---rgf, 2003-03-15
 */
inline void set_global_vars (JNIEnv * env, jobject obj)
{
#ifdef DEBUG2
   fprintf(stderr, "set_global_vars: just entered...\n");
#endif

        // a new instance in hand?
    if ( env->IsSameObject(obj, globObj) == FALSE )
    {
        globEnv=env;        // save TID
            // assign the resulting object reference
        globORef=globObj=MT_Java_env_set(env, obj);

#ifdef DEBUG2
   fprintf(stderr, "!!! set_global_vars: env=[%p], obj=[%p], ref|globOref|globObj=[%p]\n",
                   env, obj, globObj);
   showInfos4jobject(env, globObj, "globObj==globORef");
#endif
    }

#ifdef DEBUG2
   fprintf(stderr, "set_global_vars: about to leave...\n");
#endif
}






   // declare functions (define signatures)
APIRET APIENTRY BSF                         ( PSZ name, ULONG argc, PRXSTRING argv, PSZ queuename, PRXSTRING retstr);

   // same entries, slightly different signature than above
APIRET APIENTRY BsfDropFuncs                ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
APIRET APIENTRY BsfInvokedBy                ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
APIRET APIENTRY BsfLoadFuncs                ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
APIRET APIENTRY BsfLoadJava                 ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
APIRET APIENTRY BsfQueryAllFunctions        ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
APIRET APIENTRY BsfQueryRegisteredFunctions ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
APIRET APIENTRY BsfUnloadJava               ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
APIRET APIENTRY BsfVersion                  ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );

    // ---rgf, 2003-08-06: allow Rexx to retrieve its TID (i.e. Java's "JNIEnv" object)
APIRET APIENTRY BsfGetTID                   ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );
    // ---rgf, 2003-08-06: allow Rexx to use the Java environment of another Rexx thread
APIRET APIENTRY BsfAttachToTID              ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr );

    // ---rgf, 2006-01-27: allow catching Rexx error messages to be used as the error text in a Java exception
    //                     this way the Java side can parse and locate the cause, line# and col# (if given) of the error
// APIRET APIENTRY RGF_RXSIO_EXIT_NAME              ( LONG exitNumber, LONG subFunction, PEXIT parmBlock );
#ifdef OS2
typedef PUCHAR PEXIT;
#endif

LONG APIENTRY RGF_RXSIO_EXIT_NAME              ( LONG exitNumber, LONG subFunction, PEXIT parmBlock );

/*********************************************************************/
/* ApiFncTable                                                       */
/*   Array of names of the REXXASP1 functions.                       */
/*   This list is used for registration and deregistration.          */
/*********************************************************************/
PSZ ApiFncTableOrdered[] =  // table containing the external Rexx function order to be used if displaying them
{
    "BSF"                         ,
    "BsfAttachToTID"              , // ---rgf, 2003-08-06
    "BsfDropFuncs"                ,
    "BsfGetTID"                   , // ---rgf, 2003-08-06
    "BsfInvokedBy"                ,
    "BsfLoadFuncs"                ,
#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
    "BsfLoadJava"                 ,
#endif
    "BsfQueryAllFunctions"        ,
    "BsfQueryRegisteredFunctions" ,

#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
    "BsfUnloadJava"               , // ---rgf, 2005-06-02, JNI would not unload
#endif
    "BsfVersion"
};

PSZ  ApiFncTable[] =     // table of functions to be registered with Rexx
   {
       "BSF",                        // interface for Rexx to Java
       "BsfDropFuncs",               // unregister all of these functions
       "BsfInvokedBy",               // allows querying for invocation type of this DLL

#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
       "BsfLoadJava",                // load the JVM by creating a new instance of BSFManager, if loaded by Rexx, using JNI's NewGlobalRef()
#endif

       "BsfQueryAllFunctions",       // fills in a stem with the names of all functions;
                                     // this *MUST* be the last listed function; it does not get registered;
                                     // as this was done already on the Rexx side;
       "BsfQueryRegisteredFunctions",// fills in a stem with the names of all functions;
                                     // this *MUST* be the last listed function; it does not get registered;
                                     // as this was done already on the Rexx side;

#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
       "BsfUnloadJava",  // ---rgf, 2005-06-02, JNI would not unload             // unload the JVM, if loaded by Rexx, calling JNI's DeleteGlobalRef()
#endif
       "BsfVersion",                 // returns the version number in the form "MajorNumber"."YYYYMMDD"

       "BsfAttachToTID",             // ---rgf, 2003-08-06, attaches a Rexx thread to the Java environment of another running Rexx thread
       "BsfGetTID",                  // ---rgf, 2003-08-06, returns the Java environment pointer which serves as the TID as far as Java is concerned

       "BsfLoadFuncs"                // (*MUST* be last!) already loaded (registered) by the Rexx programmer
   };

   // 2003-01-20, pointer to functions (for registering: *MUST* be same sequence as above!)
PFN  PApiFncTable[] =
   {
       (PFN) BSF,                       // interface for Rexx to Java
       (PFN) BsfDropFuncs,              // unregister all of these functions
       (PFN) BsfInvokedBy,              // returns "0" (no invocation, hence no Java present),
                                        //   "1" (bsf4rexx loaded via Java), "2" (bsf4rexx loaded via Rexx)

#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
       (PFN) BsfLoadJava,               // load the JVM by creating a new instance of BSFManager, if loaded by Rexx,
#endif

       (PFN) BsfQueryAllFunctions,       // fills in a stem with the names of the BSF functions
       (PFN) BsfQueryRegisteredFunctions,// fills in a stem with the names of the BSF functions

#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
       (PFN) BsfUnloadJava,  // ---rgf, 2005-06-02, JNI would not unload           // unload the JVM, if loaded by Rexx, calling JNI's DeleteGlobalRef()
#endif
       (PFN) BsfVersion,                // returns the version number of this package

       (PFN) BsfAttachToTID,   // ---rgf, 2003-08-06, attaches a Rexx thread to the Java environment of another running Rexx thread
       (PFN) BsfGetTID,        // ---rgf, 2003-08-06, returns the Java environment pointer which serves as the TID as far as Java is concerned

       (PFN) BsfLoadFuncs           // already loaded (registered) by the Rexx programmer, must be last in list!

   };


   // 2003-01-26, array of functions to be loaded, if BSF4Rexx is invoked/loaded by Java
PSZ  ApiFncTable4Java[] =     // table of functions to be registered with Rexx
   {
       "BSF",                           // interface for Rexx to Java
       "BsfInvokedBy",                  // allows querying for invocation type of this DLL
       "BsfVersion",                    // returns the version number in the form "MajorNumber"."YYYYMMDD"
       "BsfQueryAllFunctions",           // fills in a stem with the names of all functions

       "BsfAttachToTID"              , // ---rgf, 2003-08-06, attaches a Rexx thread to the Java environment of another running Rexx thread
       "BsfGetTID"                   , // ---rgf, 2003-08-06, returns the Java environment pointer which serves as the TID as far as Java is concerned

       "BsfQueryRegisteredFunctions"     // fills in a stem with the names of all functions
   };

   // 2003-01-26, pointer to functions (for registering: *MUST* be same sequence as above!)
PFN  PApiFncTable4Java[] =
   {
       (PFN) BSF,                       // interface for Rexx to Java
       (PFN) BsfInvokedBy,              // returns "0" (no invocation, hence no Java present), //   "1" (bsf4rexx loaded via Java), "2" (bsf4rexx loaded via Rexx)
       (PFN) BsfVersion,                // unregister all of these functions
       (PFN) BsfQueryAllFunctions,       // fills in a stem with the names of the BSF functions

       (PFN) BsfAttachToTID,   // ---rgf, 2003-08-06, attaches a Rexx thread to the Java environment of another running Rexx thread
       (PFN) BsfGetTID,        // ---rgf, 2003-08-06, returns the Java environment pointer which serves as the TID as far as Java is concerned


       (PFN) BsfQueryRegisteredFunctions // fills in a stem with the names of the BSF functions
   };





#ifdef CHECK_4_FORGOTTEN_BSF_FUNCTIONS
   // 2003-04-30: register external Rexx functions, if "BSF" is not registered and
   //             Java is about to have a Rexx program executed; this makes sure that
   //             every such Rexx program has the ApiFncTable4Java[] external functions registered
inline void makeSureBSF_isRegistered ()
{
    // "BSF" must be loaded, if not yet, load the
//    if (RexxQueryFunction("BSF") == RXFUNC_NOTREG )     // "BSF" *not* registered !
    {
#ifdef DEBUG2        // ---rgf, 2003-04-30
   fprintf(stderr, "\n\tmakeSureBSF_isRegistered(): just arrived...\n");
#endif

        INT    entries;                      /* Num of entries             */
        INT    j;                            /* Counter                    */
        entries = sizeof(ApiFncTable4Java)/sizeof(PSZ);    // table with function names to be registered

        long res=0l, resTmp=0l;                  // initialize to 0l
        for (j = 0; j < entries; j++)
        {
#ifdef DEBUG
    fprintf(stderr, "\t===> BsfLoadFuncs(): testing j=%d, resTmp=%d, '%s' (makeSure_BSF_isRegistered)\n", j, RexxQueryFunction(ApiFncTable4Java[j]), ApiFncTable4Java[j]);
#endif
            if (RexxQueryFunction(ApiFncTable4Java[j])==RXFUNC_NOTREG)
            {
                // 2003-01-20, making functions process-local by using RexxRegisterFunctionExe() instead of ...Dll()
                resTmp = RexxRegisterFunctionExe(ApiFncTable4Java[j], PApiFncTable4Java[j]);

#ifdef DEBUG2_NIXI        // ---rgf, 2003-04-30
   fprintf(stderr, "\t===> BsfLoadFuncs(): re-registering j=%d, resTmp=%d, '%s' (makeSure_BSF_isRegistered)\n", j, resTmp, ApiFncTable[j]);
#endif
            }

        }

      #ifdef DEBUG2        // ---rgf, 2003-04-30
         fprintf(stderr, "makeSureBSF_isRegistered():(): about to leave...\n\n");
      #endif
    }
}
#endif



    // short of a make_upper macro/function, this is a little hack, ---rgf, 2003-01-27
inline void make_upper (char * string)
{
    for (; *string; string++)   // loop over characters
    {
        *string=toupper(*string);   // translate characters to uppercase
    }
}

/*-----------------------------------------------------------------------------
 * Create a REXX variable of the specified name and bind the value to it.
 *
 * [Thanks to Mark Hessling (2003-01-27) !!]
 *
 *----------------------------------------------------------------------------*/
int SetRexxVariable
   ( char *name, int namelen, char *value, int valuelen )
{
   ULONG  rc=0L;
   SHVBLOCK       shv;

   // already done elsewhere ( void )make_upper( name ); /* upper-case the variable name */
   shv.shvnext = ( SHVBLOCK* )NULL;
   shv.shvcode = RXSHV_SET;
   MAKERXSTRING( shv.shvname, name, ( ULONG )namelen );
   MAKERXSTRING( shv.shvvalue, value, ( ULONG )valuelen );
   shv.shvnamelen = shv.shvname.strlength;
   shv.shvvaluelen = shv.shvvalue.strlength;
   // assert( shv.shvname.strptr );
   // assert( shv.shvvalue.strptr );
   rc = RexxVariablePool( &shv );
   if ( rc == RXSHV_OK
   ||   rc == RXSHV_NEWV )
      return( 0 );
   else
      return( 1 );
}


/*********************************************************************/
/* Queries how BSF4Rexx was invoked and whether JVM is present       */
/*    returns: 0 ... no JVM present                                  */
/*             1 ... JVM present, bsf4rexx invoked by Java           */
/*             2 ... JVM present, bsf4rexx invoked by Rexx as an     */
/*                   external function package                       */
/*                                                                   */
/* ---rgf, 2003-01-21                                                */
/*********************************************************************/
APIRET APIENTRY BsfInvokedBy(
  PSZ       name,                      /* Function name              */
  LONG      numargs,                   /* Number of arguments        */
  RXSTRING  args[],                    /* Argument array             */
  PSZ       queuename,                 /* Current queue              */
  PRXSTRING retstr )                   /* Return RXSTRING            */
{
#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfInvokedBy(): just arrived\n"); zeigeGlobs();    // show values for global variables
#endif

    if (globObj == NULL)                // not invoked yet or JVM got unloaded in the meantime
    {
        strcpy(retstr->strptr, "0");
    }
    else if (globJvm == NULL)           // invoked by Java via BSF (bsf4rexx)
    {
        strcpy(retstr->strptr, "1");
    }
    else                                // invoked by Rexx (bsf4rexx), JVM is loaded
    {
        strcpy(retstr->strptr, "2");
    }
    retstr->strlength = strlen(retstr->strptr); // set proper string length

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfInvokedBy(): about to leave...\n\n");
#endif

  return VALID_ROUTINE;
}




#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
    // do the "gory" work
    long RgfUnloadJava()
    {
        long ret=1l;    // default return code, indicate that no real unloading took place (JNI 1.1 restriction)
            // save old pointers/handles
        oldGlobJvm = globJvm  ;
        oldGlobORef= globORef ;
        oldGlobObj = globObj  ;
        oldGlobMid = globMid  ;

    /* unloading/destroying of the JVM will not really unload the JVM, hence keep it for
       possible later re-usage */

    /* this would be the code to destroy/unload the JVM

            // o.k. now reset everything to initial state
        if (globORef != NULL) {
            globEnv->DeleteGlobalRef(globORef); // delete global reference
            globORef=NULL;      // don't use anymore, set to NULL
        }

         long  ret=globJvm->DestroyJavaVM ( );    // destroy JVM
    */

            // reset global variables
        globJvm  = NULL;
        globORef = NULL;
        globObj  = NULL;
        globMid  = NULL;

        return ret;
    }


    /*********************************************************************/
    /* unload Java, according to tutorial: does not really work on       */
    /*              Java 1.1, will always return an error                */
    /*                                                                   */
    /* returns:                                                          */
    /*         -1   ... indicate everything o.k., but JVM cached (JNI1.1)*/
    /*         -999 ... JVM was not loaded by Rexx, aborting             */
    /*         -998 ... no JVM loaded at present, aborting               */
    /*                                                                   */
    /* ---rgf, 2003-01-15,21, 26                                         */
    /*********************************************************************/
    APIRET APIENTRY BsfUnloadJava(
      PSZ       name,                      /* Function name              */
      LONG      numargs,                   /* Number of arguments        */
      RXSTRING  args[],                    /* Argument array             */
      PSZ       queuename,                 /* Current queue              */
      PRXSTRING retstr )                   /* Return RXSTRING            */
    {
        JDK1_1InitArgs  vm_args;
        jint            res;
        jclass          cls;
        jmethodID       mid;
        jstring         str;

    #ifdef DEBUG        // ---rgf, 2003-04-30
        fprintf(stderr, "BsfUnloadJava(): just arrived, \n"); zeigeGlobs();    // show values for global variables
    #endif

        if (globJvm == NULL) // JVM was not loaded by Rexx, hence show error
        {
            fprintf(stderr, "BSFUnloadJava(): JVM was not started by Rexx, aborting!\n");
            strcpy(retstr->strptr, "-999"); // indicate no JVM loaded
            retstr->strlength = strlen(retstr->strptr); // set proper string length
            return INVALID_ROUTINE;
        }

        if (globMid == NULL) // JVM is not loaded, error!
        {
            fprintf(stderr, "BSFUnloadJava(): no JVM to unload, aborting!\n");
            strcpy(retstr->strptr, "-998");             // indicate JVM is not loaded
            retstr->strlength = strlen(retstr->strptr); // set proper string length
            return INVALID_ROUTINE;
        }

        long ret=RgfUnloadJava();   // do the unloading, ignore anything for the moment (as long as JNI 1.1 is used)

        strcpy(retstr->strptr, "1");     // always return "1" to indicate that JVM was not really unloaded
        retstr->strlength = strlen(retstr->strptr); // set proper string length

    #ifdef DEBUG        // ---rgf, 2003-04-30
        zeigeGlobs();    // show values for global variables
        fprintf(stderr, "BsfUnloadJava(): about to leave...\n\n");
    #endif

        return VALID_ROUTINE;
    }
#endif




/*********************************************************************/
/* load (register) all BSF-functions                                 */
/*                                                                   */
/* returns:                                                          */
/*                                                                   */
/*            0 ... registering went o.k.                            */
/*         -999 ... 'BSF' already loaded, hence abort                */
/*         -998 ... at least one registered function caused a        */
/*                  non-zero return code, hence abort                */
/*                                                                   */
/*********************************************************************/
APIRET APIENTRY BsfLoadFuncs(
  PSZ       name,                      /* Function name              */
  LONG      numargs,                   /* Number of arguments        */
  RXSTRING  args[],                    /* Argument array             */
  PSZ       queuename,                 /* Current queue              */
  PRXSTRING retstr )                   /* Return RXSTRING            */
{
  INT    entries;                      /* Num of entries             */
  INT    j;                            /* Counter                    */

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfLoadFuncs(): just arrived\n");
#endif

  if (RexxQueryFunction("BSF") != RXFUNC_NOTREG )     // "BSF" already registered!
  {
      fprintf(stderr, "BsfLoadFuncs(): 'BSF' already registered, aborting!\n");
      strcpy(retstr->strptr, "-999"); // indicate BSF already loaded (probably by Java)
      retstr->strlength = strlen(retstr->strptr); // set proper string length
      return INVALID_ROUTINE;
  }

  entries = sizeof(ApiFncTable)/sizeof(PSZ);    // table with function names to be registered
  entries--;        // make sure BsfLoadFuncs() is not registered (already happened at the Rexx side)


#ifdef DEBUG2        // ---rgf, 2003-04-30
  fprintf(stderr, "\t... registering %d functions with Rexx ...\n", entries);
#endif

  long res=0l, resTmp=0l;                  // initialize to 0l
  for (j = 0; j < entries; j++)
  {
      // 2003-01-20, making functions process-local by using RexxRegisterFunctionExe() instead of ...Dll()
      resTmp = RexxRegisterFunctionExe(ApiFncTable[j], PApiFncTable[j]);

#ifdef DEBUG2        // ---rgf, 2003-04-30
   fprintf(stderr, "\t===> BsfLoadFuncs(): j=%d, resTmp=%d, '%s'\n", j, resTmp, ApiFncTable[j]);
#endif

      if (resTmp != 0l)     // something went wrong with registering this function
      {
          fprintf(stderr,"BsfLoadFuncs(): error '%d' while registering function '%s'\n", resTmp, ApiFncTable[j]);
      }
      res+=resTmp;      // just add them up
  }


  if (res != 0l)          // at least one of the functions could not be registerd, abort
  {
      strcpy(retstr->strptr, "-998"); // indicate that registering caused at least one problem
      retstr->strlength = strlen(retstr->strptr); // set proper string length
      return INVALID_ROUTINE;
  }

  strcpy(retstr->strptr, "0");     // registering went o.k.
  retstr->strlength = strlen(retstr->strptr); // set proper string length

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfLoadFuncs(): about to leave...\n\n");
#endif

  return VALID_ROUTINE;
}


/*********************************************************************/
/* unregisters all BSF-functions                                     */
/*                                                                   */
/* returns:                                                          */
/*                                                                   */
/*            0 ... deregistering went o.k.                          */
/*         -998 ... at least one deregistering function caused a     */
/*                  non-zero return code, hence abort                */
/*                                                                   */
/*********************************************************************/

APIRET APIENTRY BsfDropFuncs(
  PSZ       name,                      /* Function name              */
  LONG      numargs,                   /* Number of arguments        */
  RXSTRING  args[],                    /* Argument array             */
  PSZ       queuename,                 /* Current queue              */
  PRXSTRING retstr )                   /* Return RXSTRING            */
{

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfDropFuncs(): just arrived\n");
   zeigeGlobs();    // show values for global variables
#endif

  INT    entries;                      /* Num of entries             */
  INT    j;                            /* Counter                    */
  long res=0l, resTmp=0l;               // initialize to 0l

  entries = sizeof(ApiFncTable)/sizeof(PSZ);

#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
  long ret=RgfUnloadJava();     // unload the JVM (pseudo unload due to JNI 1.1 restrictions)
#endif

  for (j = 0; j < entries; j++)
  {

#ifdef DEBUG2        // ---rgf, 2003-04-30
   fprintf(stderr, "\t===> BsfDropFuncs(), 1) RexxQueryFunc('%s')=%p\n", ApiFncTable[j], RexxQueryFunction(ApiFncTable[j]));
#endif

      resTmp=RexxDeregisterFunction(ApiFncTable[j]);

#ifdef DEBUG2        // ---rgf, 2003-04-30
   fprintf(stderr, "\t===> BsfDropFuncs(), 2) resTmp=%d, function: '%s'\n", resTmp, ApiFncTable[j]);
#endif

      if (resTmp != 0l)                 // something went wrong
      {
          fprintf(stderr,"BsfDropFuncs(): error '%d' while deregistering function '%s'\n", resTmp, ApiFncTable[j]);
      }
      res+=resTmp;

            // hmm, Object Rexx returns "0", Regina returns "30" ("function not registered") ???
            // if registering thereafter, Regina returns "10" ("function already registered") !
  }

  if (res != 0l)          // at least one of the functions could not be deregistered, abort
  {
      strcpy(retstr->strptr, "-998"); // indicate something went wrong while deregistering
      retstr->strlength = strlen(retstr->strptr); // set proper string length
      return INVALID_ROUTINE;
  }

  strcpy(retstr->strptr, "0");                  // deregistering went o.k.
  retstr->strlength = strlen(retstr->strptr);   // set proper string length

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfDropFuncs(): about to leave...\n\n");
#endif

  return VALID_ROUTINE;
}


/*********************************************************************/
/* returns the version number                                        */
/*                                                                   */
/* returns:                                                          */
/*                                                                   */
/*            x.YYYYMMDD "MajorNumber"."Date"                        */
/*                                                                   */
/*********************************************************************/

APIRET APIENTRY BsfVersion(
  PSZ       name,                      /* Function name              */
  LONG      numargs,                   /* Number of arguments        */
  RXSTRING  args[],                    /* Argument array             */
  PSZ       queuename,                 /* Current queue              */
  PRXSTRING retstr )                   /* Return RXSTRING            */
{

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfVersion(): just arrived\n");
#endif

  strcpy(retstr->strptr, BSF_VERSION);          // version number
  retstr->strlength = strlen(retstr->strptr);   // set proper string length

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfVersion(): about to leave...\n\n");
#endif

  return VALID_ROUTINE;
}


/*********************************************************************/
/* fills in a stem with the function names                           */
/*                                                                   */
/* returns:                                                          */
/*                                                                   */
/*            0 ... function executed o.k.                           */
/*         -999 ... supplied stem name too long, hence abort         */
/*                                                                   */
/*********************************************************************/

APIRET APIENTRY BsfQueryAllFunctions(
  PSZ       name,                      /* Function name              */
  LONG      numargs,                   /* Number of arguments        */
  RXSTRING  args[],                    /* Argument array             */
  PSZ       queuename,                 /* Current queue              */
  PRXSTRING retstr )                   /* Return RXSTRING            */
{

#ifdef DEBUG        // ---rgf, 2003-04-30
    fprintf(stderr, "BsfQueryAllFunctions(): just arrived\n");
#endif

    char varname[255], value[10];
    char stem_name[255];
    int entries = sizeof(ApiFncTableOrdered)/sizeof(PSZ), rc;  // table with function names to be registered
    int j=0; // --rgf, 2003-04-03/2003-04-14: keeping gcc happy


    if (numargs==0 || args[0].strlength==0)     // no stem-name given, use "BSFLISTFUNCTIONS." as default
    {
        strcpy( stem_name, "BsfQueryAllFunctions.");  // default name for this stem
    }

    else if (args[0].strlength>244)             // variable name too long 244+dot(1char)+max_digits(=10)+string_end_char(x00)
    {
        fprintf(stderr, "BsfQueryAllFunctions(): supplied stem name ('%s') too long ('%p' characters exceed the maximum of 244 characters), aborting!\n", args[0].strptr, args[0].strlength);
        strcpy(retstr->strptr, "-999");         // indicate stem-name too long
        retstr->strlength = strlen(retstr->strptr); // set proper string length
        return INVALID_ROUTINE;
    }

    else
    {
        strcpy( stem_name, args[0].strptr);       // use whatever the user supplied
    }

    make_upper(stem_name);      // uppercase the stem-name

    for (j = 0; j < entries; j++)
    {
            (void)sprintf(varname, "%s%u", stem_name, j+1);
            rc = SetRexxVariable( varname, strlen(varname), ApiFncTableOrdered[j] , strlen(ApiFncTableOrdered[j]) );
    }

    sprintf(value, "%u", j);                    // give number of elements in stem array
    (void)sprintf(varname, "%s0", stem_name);
    rc = SetRexxVariable( varname, strlen(varname), value, strlen(value));


  strcpy(retstr->strptr, "0");                  // return value
  retstr->strlength = strlen(retstr->strptr);   // set proper string length

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfQueryAllFunctions(): about to leave...\n\n");
#endif

  return VALID_ROUTINE;
}



/*********************************************************************/
/* fills in a stem with the function names                           */
/*                                                                   */
/* returns:                                                          */
/*                                                                   */
/*            0 ... function executed o.k.                           */
/*         -999 ... supplied stem name too long, hence abort         */
/*                                                                   */
/*********************************************************************/

APIRET APIENTRY BsfQueryRegisteredFunctions(
  PSZ       name,                      /* Function name              */
  LONG      numargs,                   /* Number of arguments        */
  RXSTRING  args[],                    /* Argument array             */
  PSZ       queuename,                 /* Current queue              */
  PRXSTRING retstr )                   /* Return RXSTRING            */
{

#ifdef DEBUG        // ---rgf, 2003-04-30
    fprintf(stderr, "BsfQueryRegisteredFunctions(): just arrived\n");
#endif

    char varname[255], value[10];
    char stem_name[255];
    int entries, rc;

    if (numargs==0 || args[0].strlength==0)     // no stem-name given, use "BSFLISTFUNCTIONS." as default
    {
        strcpy( stem_name, "BsfQueryRegisteredFunctions.");  // default name for this stem
    }

    else if (args[0].strlength>244)             // variable name too long 244+dot(1char)+max_digits(=10)+string_end_char(x00)
    {
        fprintf(stderr, "BsfQueryRegisteredFunctions(): supplied stem name ('%s') too long ('%p' characters exceed the maximum of 244 characters), aborting!\n", args[0].strptr, args[0].strlength);
        strcpy(retstr->strptr, "-999");         // indicate stem-name too long
        retstr->strlength = strlen(retstr->strptr); // set proper string length
        return INVALID_ROUTINE;
    }

    else
    {
        strcpy( stem_name, args[0].strptr);       // use whatever the user supplied
    }

    make_upper(stem_name);      // uppercase the stem-name

    entries=sizeof(ApiFncTableOrdered)/sizeof(PSZ);

    int i=0, j=0;

    for (i=0; i<entries; i++) {             // loop over all functions
        if (! RexxQueryFunction(ApiFncTableOrdered[i]))    // is the function registered at the moment?
        {
            (void)sprintf(varname, "%s%u", stem_name, ++j);
            rc = SetRexxVariable( varname, strlen(varname), ApiFncTableOrdered[i] , strlen(ApiFncTableOrdered[i]) );
        }
    }

    sprintf(value, "%u", j);                    // give number of elements in stem array
    (void)sprintf(varname, "%s0", stem_name);
    rc = SetRexxVariable( varname, strlen(varname), value, strlen(value));

  strcpy(retstr->strptr, "0");                  // return value
  retstr->strlength = strlen(retstr->strptr);   // set proper string length

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfQueryAllRegisteredFunctions(): about to leave...\n\n");
#endif

  return VALID_ROUTINE;
}




    // ---rgf, 2003-08-06: allow Rexx to retrieve its TID (i.e. Java's "JNIEnv" object)
APIRET APIENTRY BsfGetTID
     ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr )
{

#ifdef DEBUG       // ---rgf, 2003-04-30
   fprintf(stderr, "BsfGetTID(): just arrived\n");
#endif

         // get the JVM-pointer
    JavaVM *vm= (globJvm==NULL ? globJavaVM : globJvm);    // get the JVM interface pointer
    JNIEnv *env=NULL;       // to receive the thread specific env-pointer/TID

    rgfAttachCurrentThread(vm, env);

        // get a char-array with enough space to contain a hexstring for a pointer with a trailing \0
    char pvKeyStr [CONST_LENGTH_OF_POINTER_0]="";// get a char array whith enough room to store a pointer as a hexstring value

        // render pointer as a hexstring value
    sprintf(pvKeyStr, "%p%c", env, 0);      // create a pointer hexstring value representation with a trailing \0

    strcpy(retstr->strptr, pvKeyStr);       // version number
    retstr->strlength = strlen(retstr->strptr);   // set proper string length

#ifdef USE_DETACH_CURRENT_THREAD
    rgfDetachCurrentThread(vm, env);    // seems to bomb Linux
#endif

#ifdef DEBUG        // ---rgf, 2003-04-30

   fprintf(stderr, "BsfGetTID(): returning TID=[%p]...\n\n", env);
#endif

  return VALID_ROUTINE;
}




    // ---rgf, 2003-08-06: allow Rexx to use the Java environment of another Rexx thread
APIRET APIENTRY BsfAttachToTID ( PSZ name, LONG numargs, RXSTRING args[], PSZ queuename, PRXSTRING retstr )
{

#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfAttachToTID(): just arrived\n");
#endif

   if ( ! RXVALIDSTRING(args[0]))    // nothing there to do
   {
       return INVALID_ROUTINE;
   }

   // retrieve the passed in argument and re-create the JNIEnv-pointer
    JNIEnv *argEnv=NULL;
    sscanf(args[0].strptr, "%p", &argEnv);       // scan pointer hexstring value into pointer

    if (argEnv==NULL)       // no RexxAndJava-instance associated so far !
    {
        fprintf(stderr, "BSF4Rexx.BsfAttachToTID: invalid TID [%s], aborting...\n", args[0].strptr);
        return INVALID_ROUTINE;
    }

         // get the JVM-pointer
    JavaVM *vm= (globJvm==NULL ? globJavaVM : globJvm);    // get the JVM interface pointer
    JNIEnv *env=NULL;       // to receive the thread specific env-pointer/TID

        // get correct JNIEnv object for this thread !
    rgfAttachCurrentThread(vm, env);

   //  bool bSame = ( env==argEnv );   // determine whether same TID, if so leave
#ifdef OS2
    BOOL
#else
    bool
#endif
    bSame = ( env==argEnv );   // determine whether same TID, if so leave

#ifdef DEBUG2
    fprintf(stderr, ">>> BsfAttachToTID(): env=[%p] == argEnv=[%p] ",
                    env, argEnv);
    fflush(stderr);
    // fprintf(stderr, "args[0]=[%8s]\n", args[0].strptr);
    fprintf(stderr, "args[0]=[%s]\n", args[0].strptr);
    fflush(stderr);
#endif

    if (!bSame)     // TID not the same, attach to it
    {
        jobject obj1=MT_Java_env_lookup( argEnv );  // try to get the object
#ifdef DEBUG2
    fprintf(stderr, "\tobj1=[%p]\n", obj1);
#endif
        if (obj1==NULL)             // no RexxAndJava-instance associated so far !
        {
            fprintf(stderr, "BSF4Rexx.BsfAttachToTID: TID [%s] not associated with a Java instance of class RexxAndJava, aborting...\n", args[0].strptr);
            return INVALID_ROUTINE;
        }
        MT_Java_env_set( env, obj1 );  // now set the object
    }

#ifdef USE_DETACH_CURRENT_THREAD
    rgfDetachCurrentThread(vm, env);   // seems to bomb linux
#endif

    // return "0" if same thread, "1" if successfully attached to other TID
    strcpy(retstr->strptr, (bSame ? "0" : "1") ); // version number
    retstr->strlength = 1;          // set proper string length


#ifdef DEBUG        // ---rgf, 2003-04-30
   fprintf(stderr, "BsfAttachToTID(): about to leave...\n\n");
#endif

    return VALID_ROUTINE;
}



/*
 * External Rexx function "BSF". This function allows Rexx programs to call into Java.
 */
APIRET APIENTRY
BSF  (  PSZ name,
        ULONG argc,
        PRXSTRING argv,
        PSZ queuename,
        PRXSTRING retstr)
     {
         // get the JVM-pointer
    JavaVM *vm= (globJvm==NULL ? globJavaVM : globJvm);    // get the JVM interface pointer
    JNIEnv *env=NULL;       // to receive the thread specific env-pointer/TID

#ifdef DEBUG
    fprintf(stderr, "BSF(): just arrived\n");
#endif

#ifdef DEBUG2
    fprintf(stderr, "\tvm=[%p], globJvm=[%p], globJavaVM=[%p]\n", vm, globJvm, globJavaVM);
    zeigeGlobs();    // show values for global variables
    // fprintf(stderr, "\tTID/env=[%p] [%p] vm=[%p] before AttachCurrentThread()...\n", env, (INT) env, vm);
#endif

        // get correct JNIEnv object for this thread !
    rgfAttachCurrentThread(vm, env);

#ifdef DEBUG2        // ---rgf, 2003-07-23
    fprintf(stderr, "\t       TID=[%p] after AttachCurrentThread(); env=[%p]==globEnv=[%p]\n",
                      env, env, globEnv );
#endif

        // get Java instance to interact with ...
    jobject obj=NULL;   // define local variable to Java instance

    env==globEnv ? obj=globObj :                // same TID, use matching instance
                   obj=MT_Java_env_lookup(env); // oops, alien thread, lookup appropriate Java instance
#ifdef DEBUG2        // ---rgf, 2003-07-23
    fprintf(stderr, "\t       WORKING with obj=[%p] ... \n", obj);
#endif


    if (obj==NULL) // o.k. possible, that Rexx thread changed context, work with default
    {
        obj=globObj;
#ifdef DEBUG2        // ---rgf, 2003-07-23
    fprintf(stderr, "\t       FALLING back to globObj=[%p] ... \n", obj);
#endif
    }


#ifdef DEBUG2
    fprintf(stderr, "\t       JAVA_LANG_STRING_CLASS_OBJECT, JAVA_EMPTY_UTF_STRING.\n");
    fprintf(stderr, "\t       JAVA_LANG_STRING_CLASS_OBJECT=[%p], JAVA_EMPTY_UTF_STRING=[%p].\n",
                              JAVA_LANG_STRING_CLASS_OBJECT, JAVA_EMPTY_UTF_STRING);
    showInfos4jobject(env, JAVA_LANG_STRING_CLASS_OBJECT , "JAVA_LANG_STRING_CLASS_OBJECT");
    showInfos4jobject(env, JAVA_EMPTY_UTF_STRING, "JAVA_EMPTY_UTF_STRING");
#endif
        //convert arguments array to Java format
        jobjectArray arr = (*env).NewObjectArray (
                                  argc,
                                  JAVA_LANG_STRING_CLASS_OBJECT,   // (*env).FindClass("java/lang/String"),
                                  JAVA_EMPTY_UTF_STRING            // (*env).NewStringUTF("")
                                                  );

#ifdef DEBUG2
    fprintf(stderr, "\tBSF(): TID=[%p] after creating ObjectArray=[%p]\n", env, arr);
#endif

        // RXSTRINGs passed from Rexx have an additional \0 appended according Object Rexx 2.1 docs
        for(ULONG i=0; i<argc; i++)
        {
            if (argv[i].strptr==NULL)   // NULL (argument missing) ?
            {
               (*env).SetObjectArrayElement(arr, i, NULL);
            }
            else                        // argument as a string in hand
            {
               (*env).SetObjectArrayElement(arr, i, (*env).NewStringUTF(argv[i].strptr));

#ifdef DEBUG_THREADS
    fprintf(stderr, "\tBSF(): TID=[%p], Rexx-arg # [%p]: [%s]\n", env, (int) i, argv[i].strptr);
            // pending exception ?
    if ( env->ExceptionOccurred() != NULL ) // this works on JRE 1.1.8 ! ---rgf, 2001-05-25
    {
         fprintf(stderr, "\t...BSF(): ExceptionOccurred=[%p] !!\n", env->ExceptionOccurred());
         env->ExceptionDescribe();      // print the stack
         env->ExceptionClear();         // clear exception in the JVM
    }
#endif

            }
        }

        // call Java method and create Rexx return value
#ifdef DEBUG1
        fprintf(stderr, "BSF(): before COM(): obj=[%p], globMid=[%p], arr=[%p]...\n",
                obj, globMid, arr);
#endif
        jstring ReturnValue = (jstring)(*env).CallObjectMethod(obj, globMid, arr);

#ifdef DEBUG1
        fprintf(stderr, "BSF(): AFTER  COM(), ReturnValue=[%p].\n", ReturnValue);
#endif

            // checking return value from Java
        if (ReturnValue!=NULL)          // value returned from Java?
        {
 //               const char *str = env->GetStringUTFChars(ReturnValue, 0);  // rgf, 2006-01-22

                // this will convert the jstring to a local single-byte string using the current locale of the session
                const char *str=JNU_GetStringNativeChars(env, ReturnValue);                // rgf, 2006-01-22
                int         len = strlen(str);

                // o.k. not enough space available, free Rexx-allocated memory, re-allocate new chunk
                if (len>=RXAUTOBUFLEN)  // if not enough space available, get a larger chunk and use it
                                        // do *not* free memory allocated by the interpreter!
                {
                   retstr->strptr = (char *) RgfAllocateMemory(len+1) ; // allocate new buffer
                }

                strcpy(retstr->strptr, str);
                retstr->strlength = len;
//                env->ReleaseStringUTFChars(ReturnValue, str); // rgf, 2006-01-22
        }
        else    // o.k. Java returned null
        {
            retstr->strptr    = NULL;   // set string pointer to NULL (as if no value was returned)
            retstr->strlength = 0;      // indicate no chars available
        }

#ifdef DEBUG_THREADS
    fprintf(stderr, "\tBSF(): TID=[%p], return-value: [%s]\n", env, retstr->strptr);
#endif

                // pending exception ?
        if ( env->ExceptionOccurred() != NULL ) // this works on JRE 1.1.8 ! ---rgf, 2001-05-25
        {
#ifdef DEBUG_THREADS
    fprintf(stderr, "\t...BSF(): ExceptionOccurred=[%p] !!\n", env->ExceptionOccurred());
#endif

#ifdef DEBUG1
   fprintf( stderr, "BSF(): pending exception from call into Java ...\n");
#endif
             env->ExceptionDescribe();      // print the stack
             env->ExceptionClear();         // clear exception in the JVM

#ifdef USE_DETACH_CURRENT_THREAD
             rgfDetachCurrentThread(vm, env);    // seems to bomb Linux
#endif
             return INVALID_ROUTINE;    // interrupt Rexx with "Incorrect call to routine!"
        }

#ifdef DEBUG1
   fprintf(stderr, "BSF(): just before vm->DetachCurrentThread()...\n");

#ifdef USE_DETACH_CURRENT_THREAD
   rgfDetachCurrentThread(vm, env);    // exception in Sun's native code 'java' on 1.4 on Linux RH 7.3
#endif

   fprintf(stderr, "BSF(): after vm->DetachCurrentThread()...\n");
#endif


#ifdef DEBUG
    fprintf(stderr, "BSF(): about to leave, TID=[%p] obj=[%p]\n\n", env, obj);
#endif
        return VALID_ROUTINE;
     }



/*
 * This will be called from Java at initialization time and makes sure
 * that the external Rexx functions named &quot;BsfInvokedBy()&quot; and
 * &quot;BSF()&quot; will get
 * registered. This way, Rexx programs being invoked from the Java side
 * have &quot;BSF&quot; available already (no need to register this function by
 * called Rexx program). Changed to "jint" on 2001-05-25.
 */
JNIEXPORT jint JNICALL

Java_org_rexxla_bsf_engines_rexx_RexxAndJava_jniRegisterBSF (JNIEnv *env, jobject obj)

     {
#ifdef DEBUG        // ---rgf, 2003-04-30
         fprintf(stderr, "..._bsf_engines_rexx_RexxAndJava_jniRegisterBSF(): just arrived\n");
#endif

#ifdef DEBUG2
         fprintf(stderr, "_jniRegisterBSF(...): env=[%p]=TID  obj=[%p]", env, obj);
         zeigeGlobs();    // show values for global variables
   fprintf(stderr, "_jniRegisterBSF(...): before globJvm=[%p], globJavaVM=[%p]\n", globJvm, globJavaVM);
#endif

        if (globJvm==NULL)          // invoked by Java, save JVM-pointer for later use
        {
           env->GetJavaVM( &globJavaVM );   // get and save JVM-pointer
        }

#ifdef DEBUG2
   fprintf(stderr, "_jniRegisterBSF(...): after  globJvm=[%p], globJavaVM=[%p]\n",globJvm, globJavaVM);
#endif

            // very first invocation ?
        if (HASHTABLE==NULL)    // create a HASHTABLE object
        {
            JNI_RUNTIME_VERSION = env->GetVersion()-65536;  // calc minor version

            jclass     ht_jc=(*env).FindClass(HASHTABLE_CLASSNAME);    // get class object for Hashtable
            jmethodID constr=(*env).GetMethodID(ht_jc, "<init>", "()V");    // get constructor
            jobject       jo=(*env).NewObject(ht_jc, constr); // create Hashtable instance


#ifdef DEBUG2
   fprintf(stderr, "\t\t---> HASHTABLE==NULL: ht_jc=[%p], jo=[%p]\n", ht_jc, jo);
   fprintf(stderr, "\t\t     JavaVersion=[%p] [%d]; JNI_RUNTIME_VERSION=[%d] [%p]\n", env->GetVersion(), env->GetVersion(), JNI_RUNTIME_VERSION, JNI_RUNTIME_VERSION );
#endif

#ifdef DEBUG2        // ---rgf, 2003-08-07
   fprintf(stderr, "\t...jniRegisterBSF(): before MonitorEnter()...\n");
#endif

            (*env).MonitorEnter(jo);    // make sure other threads are blocked
                // get and pin down java.lang.String class object
            jclass strCl=(*env).FindClass("java/lang/String");
            JAVA_LANG_STRING_CLASS_OBJECT=(jclass) (*env).NewGlobalRef(strCl);   // sava a global reference of the Hashtable class object


              // get and save MID of Java callback method
            // get and pin down java.lang.String class object
            JAVA_REXX_AND_JAVA_CLASS_OBJECT = (jclass) (*env).NewGlobalRef( env->GetObjectClass(obj)  );
            globMid = (*env).GetMethodID( JAVA_REXX_AND_JAVA_CLASS_OBJECT,
                                          JAVA_CALL_BSF,
                                          "([Ljava/lang/String;)Ljava/lang/String;" );

                // create an empty Java string (to be used in BSF() for creating a String array object
                // Java 1.2 needs the explicit global reference even for UTF-strings!
            JAVA_EMPTY_UTF_STRING = (jstring) (*env).NewGlobalRef( (*env).NewStringUTF("") );

                // get and pin down java.lang.String class object
#ifdef DEBUG2
   showInfos4jobject (env, jo, "jo"); // instance of Hashtable
#endif
            HASHTABLE=(*env).NewGlobalRef(jo);  // save a global reference to Hashtable object

#ifdef DEBUG2
   showInfos4jobject (env, HASHTABLE, "Hashtable object via NewGlobalRef(jo)..."); // instance of Hashtable
#endif
            HASHTABLE_CLASS_OBJECT=(jclass) (*env).NewGlobalRef(ht_jc);   // sava a global reference of the Hashtable class object
            // now get and save the necessary MIDs globally
            HASHTABLE_MID_CONTAINSKEY=  (*env).GetMethodID(ht_jc, "containsKey",  "(Ljava/lang/Object;)Z");
            HASHTABLE_MID_GET=          (*env).GetMethodID(ht_jc, "get",          "(Ljava/lang/Object;)Ljava/lang/Object;");
            HASHTABLE_MID_PUT=          (*env).GetMethodID(ht_jc, "put",          "(Ljava/lang/Object;Ljava/lang/Object;)Ljava/lang/Object;");
            HASHTABLE_MID_REMOVE=       (*env).GetMethodID(ht_jc, "remove",       "(Ljava/lang/Object;)Ljava/lang/Object;");


            jmethodID HT_TOSTRING=(*env).GetMethodID(ht_jc, "toString", "()Ljava/lang/String;");

#ifdef DEBUG2
   fprintf(stderr, "!!!!!!\t---> JAVA_LANG_STRING_CLASS_OBJECT=[%p]\n", JAVA_LANG_STRING_CLASS_OBJECT);
   fprintf(stderr, "!!!!!!\t---> HASHTABLE                    =[%p]\n", HASHTABLE                    );
#endif

            set_global_vars(env, obj);  // use this combination as default from now

            (*env).MonitorExit(jo); // end of critical section

#ifdef DEBUG2        // ---rgf, 2003-08-07
   fprintf(stderr, "\t...jniRegisterBSF(): after MonitorExit()...\n");
#endif
        }

        MT_Java_env_set(env, obj);  // make sure to store this thread's data in HASHTABLE

            // 2003-01-26
        int entries = sizeof(ApiFncTable4Java)/sizeof(PSZ);    // table with function names to be registered

            // register
        long res=0l, resTmp=0l;                  // initialize to 0l
        for (int j = 0; j < entries; j++)
        {
             // 2003-01-20, making functions process-local by using RexxRegisterFunctionExe() instead of ...Dll()
             resTmp = RexxRegisterFunctionExe(ApiFncTable4Java[j], PApiFncTable4Java[j]);

#ifdef DEBUG2        // ---rgf, 2003-04-30
   fprintf(stderr, "\t... tried to register: j=%d, resTmp=%d, '%s'\n", j, resTmp, ApiFncTable4Java[j]);
#endif
        }

#ifdef DEBUG2        // ---rgf, 2003-04-30
   fprintf(stderr, "..._bsf_engines_rexx_RexxAndJava_jniRegisterBSF(): about to leave...\n\n");
#endif
         return (jint) 1;   // always return true
     }


/*
 * This may be called from Java, pertains to Object Rexx only (as of 2003-01-04);
 * should wait until all cleanup within Object Rexx has been done. ---rgf, 2002-12-07, 2003-01-04
 */
JNIEXPORT jint JNICALL

Java_org_rexxla_bsf_engines_rexx_RexxAndJava_jniRexxWaitForTermination

  (JNIEnv *env, jobject obj)
     {

#ifdef DEBUG        // ---rgf, 2003-04-30
     fprintf(stderr, "..._jniRexxWaitForTermination(), just arrived\n");
#endif


#if defined (USE_OREXX) || defined( USE_REXXTRANS )
    #ifdef DEBUG2        // ---rgf, 2003-04-30
        fprintf(stderr, "\t...just about to call RexxWaitForTermination()...\n");
    #endif

        RexxWaitForTermination();       // wait for Object Rexx to re-synch ... (2003-02-25, ---rgf: doesn't really have any effect
#endif


#ifdef DEBUG2        // ---rgf, 2003-04-30
    fprintf(stderr, "..._jniRexxWaitForTermination(): about to leave...\n\n");
#endif

        return (jint) 1;               // just return something

     }
  ;


/*
 * This is a pass-thru for RexxDidRexxTerminate(), returns 0 if Object Rexx still runs,
 * 1 if Object Rexx has terminated, ---rgf, 2002-12-13
 */
JNIEXPORT jint JNICALL

Java_org_rexxla_bsf_engines_rexx_RexxAndJava_jniRexxDidRexxTerminate

  (JNIEnv *env, jobject obj)
     {

#ifdef DEBUG2        // ---rgf, 2003-04-30
    fprintf(stderr, "..._jniRexxDidRexxTerminate(), just arrived\n");
#endif

#if defined (USE_OREXX) || defined( USE_REXXTRANS )
    #ifdef DEBUG2        // ---rgf, 2003-04-30
        fprintf(stderr, "\t...about to call and return ..._jniRexxDidRexxTerminate() ...\n\n");
    #endif

        return (jint) RexxDidRexxTerminate();       // ask Object Rexx, if it is done

#else
    #ifdef DEBUG2       // ---rgf, 2003-04-30
        fprintf(stderr, "..._jniRexxDidRexxTerminate(), about to leave...\n\n");
    #endif

        return (jint) 1;        // default for non-Object Rexx is the integer value '1' for 'true'
#endif
     }
  ;






/*
 * Class:     com_ibm_bsf_engines_rexx_RexxAndJava
 * Method:    jniInitialize4Rexx
 * Signature: ()I
 *
 * This is the target from the Java side. Will be called upon initializing
 * the JVM from the Rexx side.
 *
 */
JNIEXPORT jint JNICALL Java_org_rexxla_bsf_engines_rexx_RexxAndJava_jniInitialize4Rexx

  (JNIEnv *env, jobject obj)
{
#ifdef DEBUG        // ---rgf, 2003-04-30
    fprintf(stderr, "..._jniInitialize4Rexx(): just arrived\n"); zeigeGlobs();    // show values for global variables
#endif

#ifdef DEBUG2
   fprintf(stderr, "==> NewGlobalRef()=[%p], env=[%p], obj=[%p] <== (...init4Rexx...)\n", globORef, env, obj);
#endif

    if (globJvm==NULL)          // invoked by Java, save JVM-pointer for later use
    {
        env->GetJavaVM( &globJavaVM );
    }

#ifdef DEBUG2        // ---rgf, 2003-04-30
    zeigeGlobs();    // show values for global variables
    fprintf(stderr, "..._jniInitialize4Rexx(): about to leave...\n\n");
#endif

    return (jint) 1;              // just return something which can be thought of being true
}

/*
 * This will be called from Java to invoke the Rexx interpreter. "source" contains
 * the Rexx program, "array" the arguments meant for the Rexx program.
 */
JNIEXPORT jstring JNICALL Java_org_rexxla_bsf_engines_rexx_RexxAndJava_jniRexxStart

        ( JNIEnv         *env,
          jobject         obj,
          jstring         source,
          jobjectArray    array)
     {
#ifdef DEBUG        // ---rgf, 2003-04-30
         fprintf(stderr, "..._jniRexxStart(): just arrived\n");
#endif

#ifdef DEBUG_THREADS
    fprintf(stderr, "jniRexxStart(): just arrived, env=[%p], obj=[%p], globObj=[%p]\n",env, obj, globObj);
#endif

#ifdef DEBUG2
         fprintf(stderr, "\n\tenv=[%p]=TID obj=[%p]\n", env, obj);
         zeigeGlobs();    // show values for global variables
#endif

         // set global variables for callbacks to Java (via BSF())
         set_global_vars(env, obj); // save handles "globally"

         // make a copy of the Java string containing the Rexx script to be executed
         const char      *str = env->GetStringUTFChars(source, 0);
         char      *sourceStr = (char *) RgfAllocateMemory(strlen(str)+1) ;

         strcpy(sourceStr, str);
         env->ReleaseStringUTFChars(source, str);

         // create argument array for Rexx
         PRXSTRING argList = NULL;       // pointer to array of RXSTRINGS
         jsize   arrNum = 0;
         long    numArgs= 0l;

         if (array != NULL)              // an Object array available?
         {
             arrNum    =  env->GetArrayLength(array);
             numArgs   = (long) arrNum;
         }

         if (arrNum>0)
         {
                // allocate enough memory for argument array of RXSTRINGs
            argList = (PRXSTRING) RgfAllocateMemory( sizeof(RXSTRING) * arrNum );

            for (int i = 0; i < arrNum; ++i)
            {
               if ((env->GetObjectArrayElement(array, i))==NULL)/* no argument*/
               {
                  argList[i].strptr   =NULL;
                  argList[i].strlength=0;
               }
               else        /* a string argument in hand, give it to Rexx*/
               {
                  jstring        javaStr = (jstring) env->GetObjectArrayElement(array, i);
/*
                  const char     *strArg = env->GetStringUTFChars(javaStr, 0);
                  int                len = strlen(strArg);
                  char        *tmpString =  (char *) RgfAllocateMemory(len+1) ;

                  strcpy(tmpString, strArg);
                  env->ReleaseStringUTFChars(javaStr, strArg);
*/

                  // this will convert the jstring to a local single-byte string using the current locale of Java
                  const char *tmpString=JNU_GetStringNativeChars(env, javaStr);                // rgf, 2006-01-28
                  int         len = strlen(tmpString);

                  MAKERXSTRING( argList[i], tmpString, len);/* save arg for Rexx*/
              }
            }
          }

                // Rexx program to execute
         RXSTRING        RXsourceStr[2];
         MAKERXSTRING   (RXsourceStr[0], sourceStr, strlen(sourceStr));
         PRXSTRING       Instore = &RXsourceStr[0];
         MAKERXSTRING   (RXsourceStr[1], NULL, 0);

         SHORT           ReturnCode;
         LONG            ReturnValue;

                // let Rexx allocate buffer, if needed for a result
         LONG            rc;
         RXSTRING        Result;
         MAKERXSTRING   (Result, NULL, 0);

         PSZ             ProgramName = DLLNAME ;


            // rgf, 2006-01-27: add Rexx exit handler to intercept error msg

         // PRGF_STDERR_BUFFER  rsbarr[2];
         RGF_STDERR_BUFFER   *rsbarr[2];

         RGF_STDERR_BUFFER   rsb;
         INT tmpUInt[2]={ 0, 0 };                           // 0 count, next line at offset 0
         rsb.intBuffer =tmpUInt;
         rsb.strBuffer =(PCHAR) RgfAllocateMemory(2048);    // four lines  512 bytes including \0

         strcpy(rsb.strBuffer, "Rony was here...");

         rsbarr[0]=&rsb;            // interested data
         rsbarr[1]=NULL;            // second four bytes set to NULL

         rc=RexxRegisterExitExe(          RGF_RXSIO_EXIT_NAME_STRING,    // name of the exit function
                                 (PFN)    RGF_RXSIO_EXIT_NAME,
                                 (PUCHAR) rsbarr               // user data for this exit instance
                                 );          // address of the function

#ifdef DEBUG
    fprintf(stderr, "\t...after RexxRegisterExitDll().\n", rc);
    // fprintf(stderr, "\t-->rsb-values: rsb.strBuffer=[%s], rsb.presCount|intBuffer[0]=[%d], rsb.nextEntry|intBuffer[1]=[%d]\n",
#endif

            // now define the exit_list
         RXSYSEXIT exit_list[2];

            // set exit handler infos
         exit_list[0].sysexit_name=RGF_RXSIO_EXIT_NAME_STRING;      // C function name to invoke
         exit_list[0].sysexit_code=RXSIO;                           // exit function

            // indicate no more exit handlers
         exit_list[1].sysexit_name=NULL;
         exit_list[1].sysexit_code=RXENDLST;

#ifdef DEBUG2        // ---rgf, 2003-04-30
   fprintf(stderr, "\t..._jniRexxStart: about to invoke Rexx via RexxStart().\n");
#endif


#ifdef CHECK_4_FORGOTTEN_BSF_FUNCTIONS
   // it seems that under Unix Object Rexx *sometimes* looses track of registered
   // external BSF functions
   #ifdef DEBUG
       fprintf(stderr, "...jniRexxStart(): calling makeSureBSF_isRegistered()...\n");
   #endif
         makeSureBSF_isRegistered ();    // make sure BSF() et.al. are registered for the Rexx program!
#endif

         //start Rexx
         ReturnValue = RexxStart(
                                      (LONG)       arrNum,         // LONG         ArgCount
                                      (PRXSTRING)  argList,        // PRXSTRING    ArgList
                                      (PSZ)        "a_BSF4Rexx_program",    // PSZ          ProgramName
                                      (PRXSTRING)  Instore,        // PRXSTRING    Instore
                                      (PSZ)        "BSF",          // NULL,           // PSZ          EnvName
                                      (LONG)       RXFUNCTION,     // LONG         CallType
                                      (PRXSYSEXIT) exit_list,     // PRXSYSEXIT   Exits
                                      (PSHORT)     &ReturnCode,    // PUSHORT      ReturnCode
                                      (PRXSTRING)  &Result         // PRXSTRING    Result
                         );

#ifdef DEBUG2        // ---rgf, 2003-04-30
    fprintf(stderr, "\t..._jniRexxStart(): after invoking Rexx, \n");
#endif // DEBUG

#ifdef DEBUG
    fprintf(stderr, "\t...before RexxDeregisterExit() ....\n");
    fflush(stderr);
#endif

    rc=RexxDeregisterExit( RGF_RXSIO_EXIT_NAME_STRING,   // name of the exit function
                           NULL // DLLNAME                          // it's this DLL
                       );


#ifdef DEBUG
    fprintf(stderr, "\t...after RexxDeregisterExit(), rc=[%d]\n", rc);
    fprintf(stderr, "\t-->rsb-values: rsb.strBuffer=[%s], rsb.presCount|intBuffer[0]=[%d], rsb.nextEntry|intBuffer[1]=[%d]\n",
                                      rsb.strBuffer, rsb.intBuffer[0], rsb.intBuffer[1]);
#endif


    // ---rgf, 2003-07-25: it seems that if started from Java, then
    // one needs to call AttachCurrentThread() in order for JNI to resynch or so;
    // if not done, then an error occurs without any further infos!
    JavaVM *vm= (globJvm==NULL ? globJavaVM : globJvm);    // get the JVM interface pointer
    // JNIEnv *env=NULL;       // to receive the thread specific env-pointer/TID

#ifdef DEBUG2        // ---rgf, 2003-04-30
    fprintf(stderr, "\tvm=[%p], globJvm=[%p], globJavaVM=[%p], env=[%p]\n", vm, globJvm, globJavaVM, env);
#endif // DEBUG


    // The following heals a bug: sometimes "env" does not contain
    // the correct TID/env-value for this thread anymore! problem in: Java 1.2, 1.3, 1.4 (*not* 1.1!)
        // get correct JNIEnv object for this thread !

#ifdef USE_DETACH_CURRENT_THREAD
    rgfAttachCurrentThread(vm, env);
    #ifdef DEBUG
       fprintf(stderr, "...jniRexxStart(): USING rgfAttachCurrentThread() !! ...\n");
    #endif
#else
    #ifdef DEBUG
       fprintf(stderr, "...jniRexxStart(): NOT using rgfAttachCurrentThread()...\n");
    #endif

#endif

#ifdef DEBUG2        // ---rgf, 2003-04-30
    fprintf(stderr, "\tenv=[%p]=TID nach AttachCurrentThread()\n", env);
#endif // DEBUG


        if (arrNum>0)   // free allocated memory, which was needed for Rexx arguments
        {
           for (int i = 0; i < arrNum; ++i) // loop over Rexx args
           {
              RgfFreeMemory ( argList[i].strptr );  // free argument array RXSTRING buffers
           }
           RgfFreeMemory ( argList );               // free argument array RXSTRING buffer itself
        }

        RgfFreeMemory(sourceStr);   // ---rgf, 2003-04-14, free memory reserved for the Rexx source code


#ifdef DEBUG2        // ---rgf, 2003-04-30
    fprintf(stderr, "\t..._jniRexxStart(): ReturnValue=[%p]\n", ReturnValue);
#endif


// todo: create an exception for the Java side!
        if (ReturnValue != 0l)     // error occurred, return null
        {
#ifdef DEBUG
    fprintf(stderr, "jniRexxStart(): error occurred, returning NULL, env=[%p], obj=[%p], globObj=[%p], ReturnValue=[%d]\n",env, obj, globObj, ReturnValue);
#endif
            {
// fprintf(stderr, "\t ... rsb.intBuffer[0]=[%d], rsb.intBuffer[1]=[%d]\n", rsb.intBuffer[0], rsb.intBuffer[1]);
// fprintf(stderr, "\t ... rsb.strBuffer     =[%s]\n", rsb.strBuffer);
// fprintf(stderr, "\t ... rsb.strBuffer+ 512=[%s]\n", rsb.strBuffer+ 512);
// fprintf(stderr, "\t ... rsb.strBuffer+1024=[%s]\n", rsb.strBuffer+1024);
// fprintf(stderr, "\t ... rsb.strBuffer+1536=[%s]\n", rsb.strBuffer+1536);
                int i=0, j=0;
                PCHAR threeLines[3];
                PCHAR msgBuffer=NULL;

// fprintf(stderr, "\t ... about to throw JNU_ThrowByName, here the buffer:\n[%s]\n", msgBuffer);
                if (rsb.intBuffer[0]>0)         // o.k., lines captured get the last three in order
                {
                    {
                        if (rsb.intBuffer[1]==0)                // next line to write to, so all four lines were used already
                        {
                            threeLines[0]=rsb.strBuffer+ 512;       // 2nd line
                            threeLines[1]=rsb.strBuffer+1024;       // 3rd line
                            threeLines[2]=rsb.strBuffer+1536;       // 4th line
                        }
                        else if (rsb.intBuffer[1]==1)            // next line to write to
                        {
                            threeLines[0]=rsb.strBuffer+1024;       // 2nd line
                            threeLines[1]=rsb.strBuffer+1536;       // 3rd line
                            threeLines[2]=rsb.strBuffer     ;       // 4th line
                        }
                        else if (rsb.intBuffer[1]==2)            // next line to write to
                        {
                            threeLines[0]=rsb.strBuffer+1536;       // 2nd line
                            threeLines[1]=rsb.strBuffer     ;       // 3rd line
                            threeLines[2]=rsb.strBuffer+ 512;       // 4th line
                        }
                        else if (rsb.intBuffer[1]==3)            // next line to write to
                        {
    // fprintf(stderr, "/// \\\\\\ ... rsb.intBuffer[1]=3 ! ...\n");
                            threeLines[0]=rsb.strBuffer     ;       // 2nd line
                            threeLines[1]=rsb.strBuffer+ 512;       // 3rd line
                            threeLines[2]=rsb.strBuffer+1024;       // 4th line
                        }
                    }

                    int iSize=0;                    // calc needed bytes for buffer
                    int iSizeArr[3];
                    for (i=0; i<3 && i<rsb.intBuffer[0]; i++)       // [0]...count, [1]...next write pos
                    {
                        iSizeArr[i]=strlen(threeLines[i]);
                        iSize=iSize+iSizeArr[i]+1;
                    }

                    msgBuffer=(PCHAR) RgfAllocateMemory(iSize+1);   // account for trailing \0
                    for (i=0, j=0; i<3 && i<rsb.intBuffer[0]; i++)  // [0]...count, [1]...next write pos
                    {
    // fprintf(stderr, "\t ... i=[%d], j=[%d], iSizeArr[i]=[%d], line=[%s] ...\n",i,      j,      iSizeArr[i],      threeLines[i]);

                        strncpy(msgBuffer+j, threeLines[i], iSizeArr[i]);
                        j=j+iSizeArr[i];        // position to write a newline char
                        msgBuffer[j]='\n';      // insert a newline character
                        j++;                    // next position to copy to
                    }
                    msgBuffer[iSize-1]='\0';    // no pending \n character
                }
                else        // error condition, but no text captured in the RXSIO exit !
                {
                    msgBuffer=(PCHAR) RgfAllocateMemory(512);
                    sprintf(msgBuffer, "Rexx execution error has occurred (Rexx reported error # %d)!", ReturnValue);
                }

                // throw Java exception
                JNU_ThrowByName(env, "org/apache/bsf/BSFException", msgBuffer);

                RgfFreeMemory(msgBuffer);   // make sure memory is freed
            }
           RgfFreeMemory ( rsb.strBuffer );     // free memory allocated for RXSIO exit
           return NULL;
        }
        RgfFreeMemory ( rsb.strBuffer );        // free memory allocated for RXSIO

         // --- get result and return it to Java
        jstring jResult=NULL;           // define Java String to return

        if ( Result.strptr != NULL )    // a result was returned from Rexx
        {
             if (Result.strlength==0)   // empty string?
             {
                 jResult=JAVA_EMPTY_UTF_STRING;
             }
             else                       // valid non-empty string
             {
                 jResult=env->NewStringUTF( Result.strptr );
             }
        }

#ifdef DEBUG2        // ---rgf, 2003-04-30
         fprintf(stderr, "..._jniRexxStart(): about to leave \n");
         fprintf(stderr, "\n\tenv=[%p]=TID obj=[%p]\n", env, obj);
         zeigeGlobs();    // show values for global variables
         fprintf(stderr, "\n\tVersuch, ExceptionOccured() auszufhren...\n");
         fflush(stderr);

         if (env->ExceptionOccurred() != NULL)  // ExceptionCheck() only in JNI >= 1.2
         {
                // the following works under JNI 1.1 as well
             fprintf(stderr, "\n\t\tenv->ExceptionOccurred()=[%p]\n", env->ExceptionOccurred()!=NULL);
             fflush(stderr);
         }
#endif

#ifdef DEBUG2
        fprintf(stderr, "Hey! result=[%s]\n", jResult);
#endif

#ifdef DEBUG_THREADS
    // (*env).ExceptionCheck());

    fflush(stderr);

    // if ( (*env).ExceptionCheck())
    if (env->ExceptionOccurred() != NULL)  // ExceptionCheck() only in JNI >= 1.2
    {
fprintf(stderr, "..._jniRexxStart(): ExceptionOccurred=[%p] !!\n", env->ExceptionOccurred());
        fprintf(stderr, "\t... tick 2 ...\n");
        fprintf(stderr, "\t..._jniRexxStart(): about to describe exception...");
        env->ExceptionDescribe();
        fprintf(stderr, "\t..._jniRexxStart(): about to clear exception...");
        env->ExceptionClear();
    }
#endif  // end DEBUG_THREADS


#ifdef USE_DETACH_CURRENT_THREAD
   rgfDetachCurrentThread(vm, env);
#endif

#ifdef DEBUG
    fprintf(stderr, "jniRexxStart(): about to leave, env=[%p], obj=[%p], globObj=[%p], jResult=[%p]\n",
    env, obj, globObj, jResult);
#endif
        return jResult;         // return a Java String
     }





        // ===>
        // ---rgf, 2006-01-27: use a RXSIO exit to capture the error-strings and return them in form of a Java exception
        // <===
// APIRET APIENTRY RGF_RXSIO_EXIT_NAME ( LONG exitNumber, LONG subFunction, PEXIT parmBlock )
LONG APIENTRY RGF_RXSIO_EXIT_NAME ( LONG exitNumber, LONG subFunction, PEXIT parmBlock )
{
        // define variables
    USHORT            query_flag=0;     // for RexxQueryExit(): RXEXIT_OK or RXEXIT_NOTREG
    RGF_STDERR_BUFFER *user_info[2];
    LONG              rc=0;

#ifdef DEBUG
         fprintf(stderr, "\n---\ndebug - %s(): just arrived, exitNumber=[%d], subFunction=[%d], parmBlock=[%p]\n",
                         RGF_RXSIO_EXIT_NAME_STRING,
                         exitNumber, subFunction, parmBlock);
         fflush(stderr);
#endif

    if (subFunction!=RXSIOTRC)
    {
        return RXEXIT_NOT_HANDLED;  // Rexx will now write to stdout: instead of stderr: !
    }

        // save string in a round-robin fashion in the user data, first get it!
    rc=RexxQueryExit(RGF_RXSIO_EXIT_NAME_STRING,
                     NULL,                  // area anchor from Rexx
                     &query_flag,
                     (PUCHAR) user_info);

    RGF_STDERR_BUFFER   rsb = *(user_info[0]);      // get access to our data structure

    if (subFunction==RXSIOTRC)
    {
        RXSIOTRC_PARM *tparm = ( RXSIOTRC_PARM * ) parmBlock;

#ifdef DEBUG
    fprintf(stderr, "debug - RXIOTRC: %s(): \n\t--> ---> [%s]\n", RGF_RXSIO_EXIT_NAME_STRING,
                    tparm->rxsio_string.strptr);
    fprintf(stderr, "===> iCount == rsb.intBuffer[0] [%d], iNext == rsb.intBuffer[1] [%d]\n",
                    rsb.intBuffer[0], rsb.intBuffer[1]);
#endif

            // truncate lines that are too long (> 511 bytes)
       // int iLength=min(511, tparm->rxsio_string.strlength  );
       // min-function not available on Linux gcc, hence this way

        int iTmpLength=tparm->rxsio_string.strlength;
        int iLength=511;
        if (iLength>iTmpLength)
            iLength=iTmpLength;

        int iStartPos=rsb.intBuffer[1]*512;         // write position in buffer

        strncpy( rsb.strBuffer+iStartPos , tparm->rxsio_string.strptr, iLength);

        PCHAR p=rsb.strBuffer+iStartPos+iLength;    // position on last character
        *p=0;                                       // set ending 0
        if (iLength==511)   // too long? if so replace last three chars with " ..." to indicate truncation (ellipsis)
        {
             *--p=('.'); *--p=('.'); *--p=('.');    // *--p=' '; // add an ellipsis if too long
        }

        rsb.intBuffer[0]++;     // increase counter
        if (rsb.intBuffer[0]>2000000)   // in the unlikely event that this exit is called 2,000,000 times, reset counter
        {
            rsb.intBuffer[0]=5;         // just needs to be larger than maximum number of available lines (= 4)
        }

        rsb.intBuffer[1]++;     // increase next write position
        if (rsb.intBuffer[1]>3)         // roll over
        {
            rsb.intBuffer[1]=0;         // next line will be written to start of buffer
        }
#ifdef DEBUG
    fprintf(stderr, "===> startPos=[%d], length=[%d]: [%s]\n", iStartPos, iLength, rsb.strBuffer+iStartPos);
#endif

    }

    return RXEXIT_NOT_HANDLED;  // Rexx will now write to stdout: instead of stderr: !
}





#ifdef NIXI_RGF     // don't include
    // o.k. under Windows be verbose about process&thread de/creation ..., rgf, 2003-08-06
    #if defined (DEBUG_THREADS) && defined (WIN32)

        /* We provide a DLL entry function. Look at the standard documentation */
        BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD Reason, LPVOID reserved)
        {
           fprintf(stderr, "DllMain(): hinstDLL=[%p], ", hinstDLL);
           fprintf(stderr, "Reason=[%p], reserved=[%p]\n", Reason, reserved);

           // if (Reason == DLL_THREAD_ATTACH || Reason == DLL_THREAD_DETACH) {
           JNIEnv *env=NULL;       // to receive the thread specific env-pointer/TID
           if (Reason == DLL_THREAD_DETACH || Reason == DLL_PROCESS_DETACH)
           {
                        // get the JVM-pointer
                   JavaVM *vm= (globJvm==NULL ? globJavaVM : globJvm);    // get the JVM interface pointer
                       // get correct JNIEnv object for this thread !

                   rgfAttachCurrentThread(vm, env);
                   // fprintf(stderr, "DllMain(): Java-THREAD=[%p] <=== <=== <===\n", env);

#ifdef USE_DETACH_CURRENT_THREAD
               rgfDetachCurrentThread(env, vm);
#endif
           }

           switch (Reason) {
              case DLL_PROCESS_ATTACH:
                 fprintf(stderr, "\tDllMain(): DLL_PROCESS_ATTACH <===\n");
                 /* Two things to do */
                 break;
              case DLL_PROCESS_DETACH:
                  fprintf(stderr, "\tDllMain(): DLL_PROCESS_DETACH; TID=[%p] <===\n", env);
                  MT_Java_env_remove(env);
                  fprintf(stderr, "\t\t\tdid remove entry [%p] from HASHTABLE.\n", env);
                 break;
              case DLL_THREAD_ATTACH:
                  fprintf(stderr, "\tDllMain(): DLL_THREAD_ATTACH  <===\n");
                 break;
              case DLL_THREAD_DETACH:
                  fprintf(stderr, "\tDllMain(): DLL_THREAD_DETACH  TID=[%p] <===\n", env);
                  MT_Java_env_remove(env);
                  fprintf(stderr, "\t\t\tdid remove entry [%p] from HASHTABLE.\n", env);
                 break;
           }

           return(TRUE);
        }
    #endif
#endif


    // now called (JNI_OnLoad was misspelled!), 2006-01-04, ---rgf // never called! 2003-07-24
JNIEXPORT void JNICALL
     JNI_OnUnload(JavaVM *vm, void *reserved)
     {
#ifdef DEBUG3
         fprintf(stderr, "!!! in JNI_OnUnload ... (rgf) !!! vm=[%p], reserved=[%p]\n", vm, reserved);
  #ifdef DEBUG
    zeigeGlobs();    // show values for global variables
  #endif
#endif
     }

JNIEXPORT jint JNICALL
     JNI_OnLoad(JavaVM *vm, void *reserved)
     {
#ifdef DEBUG3
         fprintf(stderr, "!!! in JNI_Onload ... (rgf) !!! vm=[%p], reserved=[%p], JNI_VERSION=[%p]\n", vm, reserved, JNI_VERSION);
  #ifdef DEBUG
    zeigeGlobs();    // show values for global variables
  #endif
#endif


#ifdef DEBUG
   fprintf(stderr, "---> returning a jint: [%x] [%d]\n", JNI_VERSION_1_2, JNI_VERSION_1_2);
#endif
         return (jint) JNI_VERSION_1_2;
         // return (jint) 0x00010000 | JNI_VERSION;
     }



#ifdef ALLOW_LOADING_JVM    //   ---rgf, 2005-08-23, #idef'ed - not for OS2 and not for Macintosh
    /* 2006-01-04, ---rgf: changed handling of arguments for JNI_1_2 and up:
       - arguments are passed on to the JVM as is; this way one can use the
         "-D<name>=<value>", "-verbose[:{class|gc|jni|X-non-standard-name}[,...]]
    */


    /*********************************************************************/
    /* load Java,                                                        */
    /*  JNI_1_1:                                                         */
    /*    arg(1): optional classpath, if not given CLASSPATH will be used*/
    /*            (BEWARE: CLASSPATH path *must* not end in a slash !!)  */
    /*                                                                   */
    /*    arg(2): optional, "P"repend, "A"ppend (default) classpath      */
    /*            to the Java known classpath                            */
    /*            (this is for Java 1.1.8 *only*, will have no effect    */
    /*            if used on later Java versions)                        */
    /*                                                                   */
    /* ALL NEW BEHAVIOR FOR JNI_1_2 and up since 2006-01-04:             */
    /*                                                                   */
    /*    if Rexx-arguments are given, they are passed along to Java     */
    /*    as startup arguments (e.g. "-Djava.class.path=.")              */
    /*                                                                   */
    /*    if no Rexx argument sets 'java.class.path' and the environment */
    /*    variable CLASSPATH is given, then that value is used to pass   */
    /*    it on to the JVM (a "-Djava.class.path=$CLASSPATH"             */
    /*                                                                   */
    /*                                                                   */
    /* returns:                                                          */
    /*            0 ... JVM got loaded                                   */
    /*            1 ... JVM got loaded in earlier runs, merely made      */
    /*                  it available again                               */
    /*              ... else, whatever JNI returned                      */
    /*         -999 ... if JVM already loaded                            */
    /*         -998 ... first argument not Append nor Prepend            */
    /*         -997 ... argument #1 exceeds 1023 bytes                   */
    /*         -996 ... length of Java-classpath plus the addition of    */
    /*                  argument #1 (including PATH separator)           */
    /*                  exceeds 1023 bytes                               */
    /*         -995 ... could not create JVM                             */
    /*         -994 ... init error: could not find 'Java4Rexx.class'     */
    /*         -993 ... init error: could not find static method         */
    /*                  'Java4Rexx.createInterface4Rexx()'               */
    /*         -992 ... init error: could not find javai/jvm-DLL/so      */
    /*                                                                   */
    /* ---rgf, 2003-01-15,21; switched args on 2003-02-23                */
    /* ---rgf, 2003-08-11; dynamically loads JVM independent of version  */
    /*********************************************************************/

    APIRET APIENTRY BsfLoadJava( //2(
      PSZ       name,                      /* Function name              */
      LONG      numargs,                   /* Number of arguments        */
      RXSTRING  args[],                    /* Argument array             */
      PSZ       queuename,                 /* Current queue              */
      PRXSTRING retstr )                   /* Return RXSTRING            */
         {
             jint            res;
             jclass          cls;
             jmethodID       mid;
             jstring         str;
             JNIEnv *jniEnv=NULL;


         #ifdef DEBUG        // ---rgf, 2003-04-30
            fprintf(stderr, "BsfLoadJava(): just arrived\n"); zeigeGlobs();    // show values for global variables
         #endif

                 // JVM already loaded?
             if (globJvm!=NULL)
             {
                 strcpy(retstr->strptr, "-999");
                 retstr->strlength = strlen(retstr->strptr); // set proper string length
                 return INVALID_ROUTINE;
             }

                 // According to Sun's JNI tutorial, JNI 1.1 cannot unlaod the JVM, hence
                 // this test for re-using the loaded JVM (otherwise a runtime error occurs)
             if (oldGlobJvm != NULL) // was JVM loaded already in this run, if so restore?
             {
                     // restore old pointers/handles
                 globJvm  = oldGlobJvm ;
                 globORef = oldGlobORef;
                 globObj  = oldGlobObj ;
                 globMid  = oldGlobMid ;

                 strcpy(retstr->strptr, "1");    // return "1" to indicate a re-use did take place
                 retstr->strlength = strlen(retstr->strptr); // set proper string length
                 return VALID_ROUTINE;
             }



                  // JNI 1.2 and above ------------>
             JavaVMInitArgs vm_args2;
             rgfCreateJavaVM_1_2             rgfCreateJavaVM=NULL;
             rgfGetDefaultJavaVMInitArgs_1_2 rgfGetDefaultJavaVMInitArgs=NULL;


                 // all JNI versions ------------->
             char *cp_env=getenv("CLASSPATH");   // get value of environment variable CLASSPATH (NULL, if not set)

/////////////////////
             #if defined   ( WIN32 )
                 HINSTANCE hVM = NULL;
                 char *jni_12_library="jvm";
                 hVM=LoadLibrary( jni_12_library );   // try to load the JNI 1.1 DLL

                 #if defined( DEBUG )
                     if (hVM!= NULL)
                     {
                         char fileName[256]="";
                         GetModuleFileName(hVM, fileName, 256);
                         fprintf(stderr, "module's filename=[%s]\n", fileName);
                     }
                 #endif

             #elif defined ( UNIX )
                 PVOID      hVM = NULL;
                 char *jni_12_library="libjvm.so";
                 hVM=dlopen(jni_12_library, RTLD_LAZY | RTLD_GLOBAL );

             #elif defined ( OS2 )
                 HMODULE   hVM = NULL;
                 char *jni_12_library="jvm";
                 const INT sizeLoadError=256;
                 CHAR      LoadError[ sizeLoadError ];
                 if ( DosLoadModule( LoadError, sizeLoadError, jni_12_library, &hVM ) )
                     hVM = NULL; // handle = (handle_type)NULL;

                 #if defined( DEBUG )
                     if (hVM!= NULL)
                     {
                         CHAR fileName[256]="";
                         DosQueryModuleName( hVM, 256, fileName );
                         fprintf(stderr, "module's filename=[%s]\n", fileName);
                         { char *rgfStr="hallo";char *rgfRes="holla";rgfRes = fgets(rgfStr, 3, stdin); }
                     }
                 #endif
             #endif

                 JNI_VERSION = 2;       // using JNI 1.2 (Java version 1.2 and up

                 if ( hVM == NULL)  // oops, no Java DLL/so found
                 {
                     fprintf(stderr, "BsfLoadJava(): could not find the Java dynamic link library, aborting!\n");
                     strcpy(retstr->strptr, "-992");
                     retstr->strlength = strlen(retstr->strptr); // set proper string length
                     return INVALID_ROUTINE;
                 }



             #ifdef DEBUG2
               #if   defined ( WIN32 )
                   fprintf(stderr, "JNI-version=[%d], hVM=[%p], proc=[%p]\n", JNI_VERSION, hVM, GetProcAddress(hVM, "JNI_CreateJavaVM"));
               #elif defined ( UNIX )
                   fprintf(stderr, "JNI-version=[%d], hVM=[%p], proc=[%p]\n", JNI_VERSION, hVM, dlsym(hVM, "JNI_CreateJavaVM"));
               #elif defined (OS2)
                   fprintf(stderr, "JNI-version=[%d], hVM=[%p]\n", JNI_VERSION, hVM );
               #endif
             #endif



             #if defined   ( WIN32 )
                 rgfCreateJavaVM             = (rgfCreateJavaVM_1_2)             GetProcAddress(hVM, "JNI_CreateJavaVM"); // return the address
                 rgfGetDefaultJavaVMInitArgs = (rgfGetDefaultJavaVMInitArgs_1_2) GetProcAddress(hVM, "JNI_GetDefaultJavaVMInitArgs"); // return the address

             #elif defined ( UNIX )
                 rgfCreateJavaVM             = (rgfCreateJavaVM_1_2)             dlsym( hVM, "JNI_CreateJavaVM") ;
                 rgfGetDefaultJavaVMInitArgs = (rgfGetDefaultJavaVMInitArgs_1_2) dlsym(hVM, "JNI_GetDefaultJavaVMInitArgs");

             #elif defined ( OS2 )
                 #ifdef DEBUG
                     fprintf(stderr, "getting address of JNI_CreateJavaVM...\n");
                     { char *rgfStr="hallo";char *rgfRes="holla";rgfRes = fgets(rgfStr, 3, stdin); }
                 #endif

                 PFN addr=NULL;
                 if ( DosQueryProcAddr( hVM, 0L, "JNI_CreateJavaVM", &addr) )
                     addr = NULL;
                 rgfCreateJavaVM             = (rgfCreateJavaVM_1_2)             addr;


                 #ifdef DEBUG
                     fprintf(stderr, "getting address of JNI_GetDefaultJavaVMInitArgs...\n");
                     { char *rgfStr="hallo";char *rgfRes="holla";rgfRes = fgets(rgfStr, 3, stdin); }
                 #endif

                 if ( DosQueryProcAddr( hVM, 0L, "JNI_GetDefaultJavaVMInitArgs", &addr) )
                     addr = NULL;
                 rgfGetDefaultJavaVMInitArgs = (rgfGetDefaultJavaVMInitArgs_1_2) addr;

             #endif


             #ifdef DEBUG2
             fprintf(stderr, "after finding procAddresses; h1=[%p], h2=[%p], leaving...\n",
                             rgfCreateJavaVM, rgfGetDefaultJavaVMInitArgs);
             { char *rgfStr="hallo";char *rgfRes="holla";rgfRes = fgets(rgfStr, 3, stdin); }
             #endif
/////////////////////


             if ( rgfCreateJavaVM == NULL)  // oops, no entry point found, cannot load Java !
             {
                 fprintf(stderr, "BsfLoadJava(): could not find the Java dynamic link library, aborting!\n");
                 strcpy(retstr->strptr, "-992");
                 retstr->strlength = strlen(retstr->strptr); // set proper string length
                 return INVALID_ROUTINE;
             }

             jint resVer;
#ifdef DEBUG2
    fprintf(stderr, "BsfLoadJava(): found DLL/so, now getting the default init args.\n");
    fprintf(stderr, "               now trying to get input from keyboard:\n");
    {
    char *rgfStr="hallo";char *rgfRes="holla";rgfRes = fgets(rgfStr, 3, stdin);
    fprintf(stderr, "              str=[%s], res=[%s]\n", rgfStr, rgfRes);
    }
#endif
             vm_args2.version = JNI_VERSION_1_2 ; // 0x00010002;
             resVer = rgfGetDefaultJavaVMInitArgs(&vm_args2);

         #ifdef DEBUG1        // ---rgf, 2003-04-30
            fprintf(stderr, "BsfLoadJava(): after rgfGetDefaultJavaVMInitArgs_1_2, resVer=[%p]\n", resVer);
            { char *rgfStr="hallo";char *rgfRes="holla";rgfRes = fgets(rgfStr, 3, stdin); }
         #endif



             {    // if (JNI_VERSION == 2)   // JNI 1.2 and above
/* as of 2006-01-04 rules have changed: only supply options, if arguments are supplied (and if so
                    pass them on verbatimely!
   as of 2006-01-06: if Rexx-arg contains -Djava.class.path=, then use it; if not given and
                     CLASSPATH environment is given, use that instead; else do not set any java.class.path
*/

                    // default: no options !
             JavaVMOption *options=NULL;
             vm_args2.version = JNI_VERSION_1_2;      // set version
             vm_args2.options = NULL;                 // set options-array (containing classpath)
             vm_args2.nOptions = 0;                   // indicate how many entries in array
             vm_args2.ignoreUnrecognized = FALSE;     // report unrecognized values !

             {
                 #ifdef OS2
                     BOOL
                 #else
                     bool
                 #endif
                     bCPdefined=FALSE; // is a classpath defined in the arguments? If so, use it and forgo
                     int m=0;
                                            // a possibly CLASSPATH environment variable definition
                     char *needle="-Djava.class.path="; // needle to look for in the arguments
                     int  needleLength=strlen(needle);

                        // reserve enough space (one entry for java.lang.classpath)
                     options=(JavaVMOption *) malloc( sizeof( JavaVMOption ) * (numargs+1) );

                     for (int i=0; i<numargs; i++)  // iterate over all Rexx arguments
                     {

                         if (args[i].strptr==NULL || args[i].strlength==0)
                         {
                             continue;  // empty Rexx arg, ignore it
                         }
                         else        // o.k. classpath argument supplied, check it
                         {
                                 // determine whether java.class.path is supplied via a Rexx argument
                             bCPdefined= (bCPdefined || (strncmp(args[i].strptr, needle, needleLength)==0));
#ifdef DEBUG3
     fprintf(stderr, "BsfLoadJava(): Rexx arg # [%d]=[%s]\n", i, args[i].strptr);
     fprintf(stderr, "               bCPDefined=[%d], strncmp=[%d]\n", bCPdefined, strncmp(args[i].strptr, needle, needleLength));

#endif

                             char *ch = (char *) malloc(args[i].strlength+1);           // copy Rexx argument
                             strncpy(ch, args[i].strptr, args[i].strlength+1);
                             options[m].optionString = ch;      //
                             options[m].extraInfo    = NULL;    // Florian's Schuld! :) (2004-05-06)
#ifdef DEBUG3
    fprintf(stderr, "BsfLoadJava(): added Rexx argument [%s] as option # [%d]\n", options[m], m);
#endif
                             m++;                   // increase counter to reflect number of available options
                         }
                     }

#ifdef DEBUG3
     if (bCPdefined!=FALSE)
     {
         fprintf(stderr, "BsfLoadJava(): CLASSPATH set by a REXX argument.\n");
     }
     else
     {
         fprintf(stderr, "BsfLoadJava(): CLASSPATH was *NOT* set by a REXX argument.\n");
     }
#endif
                        // no java.class.path override in Rexx argument and CLASSPATH envirnoment variable given?
                     if ((bCPdefined==FALSE) && (cp_env!= NULL))
                     {
                         int bufLen=strlen(cp_env)+needleLength;
                         options[m].optionString = (char *) malloc(bufLen+1);   // get needed memory
                         sprintf(options[m].optionString, "%s%s", needle, cp_env);
                                 options[m].extraInfo=NULL;
                         m++;                       // increase counter to reflect number of available options
#ifdef DEBUG3
     fprintf(stderr, "BsfLoadJava(): using CLASSPATH environment variable for JVM, retrieved and use value:\t[%s]\n",
                     options[m-1].optionString);
#endif
                     }

                     vm_args2.options  = options;   // set options-array (containing classpath)
                     vm_args2.nOptions = m;         // indicate how many entries in array
#ifdef DEBUG3
    fprintf(stderr, "BsfLoadJava(): # of options for JVM is: [%d]\n\n", vm_args2.nOptions);
#endif
             }

         #ifdef DEBUG2        // ---rgf, 2003-04-30
            fprintf(stderr, "BsfLoadJava(): about to create a JVM, JNI=[%d]\n", JNI_VERSION);
            { char *rgfStr="hallo";char *rgfRes="holla";rgfRes = fgets(rgfStr, 3, stdin); }
         #endif

            // res = rgfCreateJavaVM( &globJvm, (void **) &jniEnv, &vm_args2);
            res = rgfCreateJavaVM( &globJvm, (void **) &jniEnv, &vm_args2);

         #ifdef DEBUG2        // ---rgf, 2003-04-30
            fprintf(stderr, "BsfLoadJava(): AFTER create a JVM, res=[%d], JNI=[%d]\n", res, JNI_VERSION);
         #endif
             }

             if (res<0) {
                 fprintf(stderr, "BsfLoadJava(): Can't create Java VM, rc=%p\n", res);
                 strcpy(retstr->strptr, "-995");
                 // sprintf(retstr->strptr, "%p", res);         // copy return code
                 retstr->strlength = strlen(retstr->strptr); // set proper string length
                 return INVALID_ROUTINE;
             }

             /* Find the class "Java4Rexx" */
             cls = (*jniEnv).FindClass(JAVA_4_REXX);    // or: cls = jniEnv->FindClass(JAVA_4_REXX);
             // cls = jniEnv->FindClass(JAVA_4_REXX);    // or: cls = jniEnv->FindClass(JAVA_4_REXX);
#ifdef DEBUG
     fprintf(stderr, "jniEnv=[%p], JAVA_4_REXX=[%s], cls=[%p]\n", jniEnv, JAVA_4_REXX, cls);
#endif
             if (cls == 0) {
                 fprintf(stderr, "BsfLoadJava(): initialization error, can't find class: \n\t'%s'\n", JAVA_4_REXX);
                 strcpy(retstr->strptr, "-994");
                 retstr->strlength = strlen(retstr->strptr); // set proper string length
                 return INVALID_ROUTINE;
             }

             /* get static Method "createInterface4Rexx()" */
              mid = jniEnv->GetStaticMethodID(cls, "createInterface4Rexx", "()V");
             if (mid == 0) {
                 fprintf(stderr, "BsfLoadJava(): initialization error, can't find method: \n\t'Java4Rexx.createInterface4Rexx()'\n");
                 strcpy(retstr->strptr, "-993");
                 retstr->strlength = strlen(retstr->strptr); // set proper string length
                 return INVALID_ROUTINE;
             }

             /* call the static method, which in turn will initialize BSF4Rexx by creating
                a BSFManager and having it load the "Rexx" (support) */
             strcpy(retstr->strptr, "0");
             retstr->strlength = strlen(retstr->strptr); // set proper string length

             jniEnv->CallStaticVoidMethod(cls, mid, NULL);      // invoke static method


         #ifdef DEBUG2        // ---rgf, 2003-04-30
             zeigeGlobs();    // show values for global variables
         #endif

         #ifdef DEBUG        // ---rgf, 2003-04-30
             fprintf(stderr, "BsfLoadJava(): about to leave...\n\n");
         #endif
           return VALID_ROUTINE;
         }
#endif



#ifdef __cplusplus
}               // closing bracket
#endif


